#!/usr/bin/perl

use Math::Trig;
use File::Copy;
use strict;



my $AMBERHOME = $ARGV[3];
$ENV{'AMBERHOME'} = $AMBERHOME;
my $path = $ENV{'PATH'};
$path = "$path:$AMBERHOME/bin";
$ENV{'PATH'} = $path;
if(defined($ENV{'LD_LIBRARY_PATH'}))
{
    $ENV{'LD_LIBRARY_PATH'}="$ENV{'LD_LIBRARY_PATH'}:$AMBERHOME/lib";
}
else
{
    $ENV{'LD_LIBRARY_PATH'}="$AMBERHOME/lib";
}
#### USER INPUT
my $list          =$ARGV[0];
my $OUTPUT        =$ARGV[1];
my $pdbLibrary_mt    = $ARGV[2];
my $pdb4amber ="$AMBERHOME/bin/pdb4amber";
my $tleap ="$AMBERHOME/bin/tleap";
my $sander ="$AMBERHOME/bin/sander";
my $MMPBSA ="$AMBERHOME/bin/MMPBSA.py";

## PROGRAMS and files
`mkdir $OUTPUT`;
`mkdir $OUTPUT/temp_scwrl_mt`;
## FolderNames and OUTPUT file for notes
=pod
open (FH1, "<$list") or die "YOU DIDNT OPEN LIST";
my @array=<FH1>;
chomp @array;
close (FH1);
=cut
my @array = ($list);
##make error file
open (err_mt,">$OUTPUT/Amber_scwrl_err_mt") or die "YOU DIDNT OPEN ERROR FILE";

chdir "$OUTPUT/temp_scwrl_mt";

foreach my $line(@array){
    chomp($line);
    #$line=~s/^ +//;
    #my @items=split(/\s+/,$line);
    #my $pdb = $items[0];
    #my $pdbFile = "$pdb$items[2]$items[4]";
    my$pdbFile=$line;
    #print "/nfs/amino-home/liquan/amber14/bin/pdb4amber -i $pdbLibrary/$pdbFile.pdb -o propdb1.pdb --nohyd --dry\n";
    #print "$pdb4amber -i $pdbLibrary_mt/$pdbFile.pdb -o propdb1.pdb --nohyd --dry";
    `$pdb4amber -i $pdbLibrary_mt/$pdbFile.pdb -o propdb1.pdb --nohyd --dry`;
    open(pdb1, "propdb1.pdb");
    open(pdb2, ">propdb.pdb");
    while(my $line_pdb=<pdb1>){
	if($line_pdb=~/          H/){
	    next;
	}
	printf pdb2 $line_pdb;
    }
    close(pdb1);
    close(pdb2);


    #-------------------------------------------->
    my $tleap_in = <<TLEAP;
logFile leap.log
source leaprc.ff14SB
prot=loadpdb propdb.pdb

##-- make SYSTEM one
saveamberparm prot pdb.prmtop pdb.inpcrd
savepdb prot pdb.pdb

quit
TLEAP

    open (tleap_file, ">tleap.in") or die "YOU DIDNT OPEN LIST";
    printf tleap_file $tleap_in;
    #print "$tleap -f tleap.in";
    `$tleap -f tleap.in`;
    close(tleap_file);


    #-------------------------------------------->
    my $min_gbsa_sander = <<MIN;
Stage 1 - minimization of protein for GBSA calculation
 &cntrl
  imin=1, maxcyc=50, ncyc=50, gbsa=1,
  cut=16., igb=2, ntb=0, saltcon=0.1
  ntr=0
 /
MIN

    open (min_file, ">min_gbsa.sander") or die "YOU DIDNT OPEN LIST";
    printf min_file $min_gbsa_sander;
    #print "$sander -O -i min_gbsa.sander -p pdb.prmtop -c pdb.inpcrd -r pdb.rst -o pdb.out -inf pdb.inf";
    `$sander -O -i min_gbsa.sander -p pdb.prmtop -c pdb.inpcrd -r pdb.rst -o pdb.out -inf pdb.inf`;
    close(min_file);

    #-------------------------------------------->
    my $mmpbsa_in = <<MMPBSA;
MMPBSA input file for running per-residue decomp
&general
   startframe=1, endframe=1, interval=1,
   keep_files=0, debug_printlevel=2
/
&gb
   igb=5, saltcon=0.1
/
&decomp
   idecomp=1, csv_format=0,
/
MMPBSA

    open (mmpbsa_file, ">mmpbsa.in") or die "YOU DIDNT OPEN LIST";
    printf mmpbsa_file $mmpbsa_in;
    #print "$MMPBSA -O -i mmpbsa.in -cp pdb.prmtop -y pdb.rst";
    `$MMPBSA -O -i mmpbsa.in -cp pdb.prmtop -y pdb.rst`;
    close(mmpbsa_file);

    #-------------------------------------------->
    unless(-e 'FINAL_DECOMP_MMPBSA.dat'){
	printf err_mt "$pdbFile\n";
	next;
    }

    copy ("FINAL_DECOMP_MMPBSA.dat", "$OUTPUT/$pdbFile\_DECOMP_MMPBSA.dat");
    copy ("FINAL_RESULTS_MMPBSA.dat", "$OUTPUT/$pdbFile\_RESULTS_MMPBSA.dat");
    `rm  $OUTPUT/temp_scwrl_mt/*`;
}

close(err);
exit();
