#!/usr/bin/perl

use Math::Trig;
use File::Copy;
use strict;
#use system;
#use warnings;


my $AMBERHOME = $ARGV[3];
$ENV{'AMBERHOME'} = $AMBERHOME;
my $path = $ENV{'PATH'};
$path = "$path:$AMBERHOME/bin";
$ENV{'PATH'} = $path;
if(defined($ENV{'LD_LIBRARY_PATH'}))
{
    $ENV{'LD_LIBRARY_PATH'}="$ENV{'LD_LIBRARY_PATH'}:$AMBERHOME/lib";
}
else
{
    $ENV{'LD_LIBRARY_PATH'}="$AMBERHOME/lib";
}

#### USER INPUT
my $pdb          =$ARGV[0];
my $OUTPUT        =$ARGV[1];
my $pdbLibrary_wt    = $ARGV[2];
my $pdb4amber ="$AMBERHOME/bin/pdb4amber";
my $tleap ="$AMBERHOME/bin/tleap";
my $sander ="$AMBERHOME/bin/sander";
my $MMPBSA ="$AMBERHOME/bin/MMPBSA.py";
## PROGRAMS and files
`mkdir $OUTPUT`;
`mkdir $OUTPUT/temp_scwrl`;


##make error file
open (err,">$OUTPUT/Amber_scwrl_err") or die "YOU DIDNT OPEN ERROR FILE";
chdir "$OUTPUT/temp_scwrl";


my $pdbFile = "$pdb.pdb";
`$pdb4amber -i $pdbLibrary_wt/$pdbFile -o propdb1.pdb --nohyd --dry`;

open(pdb1, "propdb1.pdb");
open(pdb2, ">propdb.pdb");
while(my $line=<pdb1>){
    if($line=~/          H/){
	next;
    }
    printf pdb2 $line;
}
close(pdb1);
close(pdb2);
    
    
#-------------------------------------------->
my $tleap_in = <<TLEAP;
logFile leap.log
source leaprc.ff14SB
prot=loadpdb propdb.pdb

##-- make SYSTEM one
saveamberparm prot pdb.prmtop pdb.inpcrd
savepdb prot pdb.pdb

quit
TLEAP

open (tleap_file, ">tleap.in") or die "YOU DIDNT OPEN LIST";
printf tleap_file $tleap_in;
`$tleap -f tleap.in`;
close(tleap_file);


#-------------------------------------------->
my $min_gbsa_sander = <<MIN;
Stage 1 - minimization of protein for GBSA calculation
 &cntrl
  imin=1, maxcyc=50, ncyc=50, gbsa=1,
  cut=16., igb=2, ntb=0, saltcon=0.1
  ntr=0
 /
MIN

open (min_file, ">min_gbsa.sander") or die "YOU DIDNT OPEN LIST";
printf min_file $min_gbsa_sander;
`$sander -O -i min_gbsa.sander -p pdb.prmtop -c pdb.inpcrd -r pdb.rst -o pdb.out -inf pdb.inf`;
close(min_file);



#-------------------------------------------->
my $mmpbsa_in = <<MMPBSA;
MMPBSA input file for running per-residue decomp
&general
   startframe=1, endframe=1, interval=1,
   keep_files=0, debug_printlevel=2
/
&gb
   igb=5, saltcon=0.1
/
&decomp
   idecomp=1, csv_format=0,
/
MMPBSA

open (mmpbsa_file, ">mmpbsa.in") or die "YOU DIDNT OPEN LIST";
printf mmpbsa_file $mmpbsa_in;
`$MMPBSA -O -i mmpbsa.in -cp pdb.prmtop -y pdb.rst`;
close(mmpbsa_file);

#-------------------------------------------->
unless(-e 'FINAL_DECOMP_MMPBSA.dat'){
    printf err "$pdb\n";
}

#print "$OUTPUT/$pdb\_DECOMP_MMPBSA.dat";
copy ("FINAL_DECOMP_MMPBSA.dat", "$OUTPUT/$pdb\_DECOMP_MMPBSA.dat");
copy ("FINAL_RESULTS_MMPBSA.dat", "$OUTPUT/$pdb\_RESULTS_MMPBSA.dat");
`rm  $OUTPUT/temp_scwrl/*`;


exit();
