#!/usr/bin/perl
#PBS -e !ERRFILE!
#PBS -o !OUTFILE!
#PBS -l !WALLTIME!
#PBS -l !NODE!

#./incorporatedProfile.pl 1a23A

use Math::Trig;
require 5.10.0;




################# directories #############################
$workdir=@ARGV[0];

#^^^^^^^^^^^^^^^^^^^^^^^^^
@AA=qw(
       C
       M
       F
       I
       L
       V
       W
       Y
       A
       G
       T
       S
       Q
       N
       E
       D
       H
       R
       K
       P
       -
       );

@AA20=qw(
       C
       M
       F
       I
       L
       V
       W
       Y
       A
       G
       T
       S
       Q
       N
       E
       D
       H
       R
       K
       P
       );

################ make fasta sequence file #################
@seqtxts=`cat $workdir/seq1.txt`;
$sequence="";
foreach $seqtxt(@seqtxts){
    goto pos6 if($seqtxt=~/\>/);
    $seqtxt=~s/\s//mg;
    $seqtxt=~s/\n//mg;
    $sequence=$sequence.$seqtxt;
  pos6:;
}
$Lch=length $sequence;

for($i=1;$i<=$Lch;$i++){
    $a=substr($sequence,$i-1,1);
    $seqQ{$i}=$a;   #only for check
    #$seqQ3{$i}=$ts{$a};
    $log{$i,$seqQ{$i}}++;
}

###############################################################
#make 'Psiblast profile.dat'
###############################################################

######## read blast.out ------------>
undef %am_blast;
open(blast,$workdir."/blast.out");
while($line=<blast>){
    if($line=~/Results from round\s+(\d+)/){
	$ROUND=$1;
    }
}
seek(blast,0,0);

$it=0;
while($line=<blast>){
    if($line=~/Results from round\s+$ROUND/){
	while($line=<blast>){
	    if($line=~/Expect =\s*(\S+)/){
		$ev=$1;
		<blast>=~/Identities =\s*\S+\s+\((\S+)\%/;
		<blast>;
		$id=$1;
		if($ev<0.001 && $id < 98){
		    $it++;
		    $ev_dim_blast{$it}=$ev;
		    while($line=<blast>){
			if($line=~/Quer\S+\s*(\d+)\s+(\S+)\s+(\S+)/){
			    $i1=$1;
			    $seq1=$2;
			    <blast>;
			    <blast>=~/Sbjc\S+\s*(\S+)\s+(\S+)\s+(\S+)/;
			    $seq2=$2;
			    <blast>;
			    ###
			    $L=length $seq1;
			    $m1=$i1-1;
			    for($i=1;$i<=$L;$i++){
				$q1=substr($seq1,$i-1,1);
				$q2=substr($seq2,$i-1,1);
				$m1++ if($q1 ne '-');
				if($q1 ne '-' && $q2 ne '-'){
				    #$log{$m1,$q2}++;  #without henikoff
				    $am_blast{$it,$m1}=$q2;  #with henikoff
				}
			    }
			    ###
			}else{
			    goto pos1;
			}
		    }
		}
	      pos1:;
	    }
	}
    }
}
close(blast);

######## include query sequence ---------->
$it++;
for($i=1;$i<=$Lch;$i++){
    $am_blast{$it,$i}=$seqQ{$i};
}

for($j=1;$j<=$it;$j++){
    for($i=1;$i<=$Lch;$i++){
	$a=$am_blast{$j,$i};
	if($a!~/\S/){
	    $am_blast{$j,$i}="-";
	}
	#print $am_blast{$j,$i};
    }
    #print "\n";
}
$it_blast =$it;

###############################################################
#make 'SIFT profile.dat'
###############################################################

######## read query.out ------------>
if( !-e $workdir."/seq2.txt.query.out"){
    print "No ".$workdir."/seq2.txt.query.out/n";
    goto hhblits;
}
undef %am_sift;
open(blast,$workdir."/seq2.txt.query.out");

$it=0;
while($line=<blast>){
    if($line=~/>gi|/){
	while($line=<blast>){
	    if($line=~/Expect =\s*(\S+)/){
		$ev=$1;
		<blast>=~/Identities =\s*\S+\s+\((\S+)\%/;
		<blast>;
		$id=$1;
		if($ev<0.001 && $id < 98){
		    $it++;
		    $ev_dim_sift{$it}=$ev;
		    while($line=<blast>){
			if($line=~/Quer\S+\s*(\d+)\s+(\S+)\s+(\S+)/){
			    $i1=$1;
			    $seq1=$2;
			    <blast>;
			    <blast>=~/Sbjc\S+\s*(\S+)\s+(\S+)\s+(\S+)/;
			    $seq2=$2;
			    <blast>;
			    ###
			    $L=length $seq1;
			    $m1=$i1-1;
			    for($i=1;$i<=$L;$i++){
				$q1=substr($seq1,$i-1,1);
				$q2=substr($seq2,$i-1,1);
				$m1++ if($q1 ne '-');
				if($q1 ne '-' && $q2 ne '-'){
				    #$log{$m1,$q2}++;  #without henikoff
				    $am_sift{$it,$m1}=$q2;  #with henikoff
				}
			    }
			    ###
			}else{
			    goto pos2;
			}
		    }
		}
	      pos2:;
	    }
	}
    }
}
close(blast);

for($j=1;$j<=$it;$j++){
    for($i=1;$i<=$Lch;$i++){
	$a=$am_sift{$j,$i};
	if($a!~/\S/){
	    $am_sift{$j,$i}="-";
	}
	#print $am_sift{$j,$i};
    }
    #print "\n";
}
$it_sift =$it;

###############################################################
#make 'hhblits profile.hhr'
###############################################################

######## read query.hhr ------------>
hhblits:;
if( !-e $workdir."/seq.hhr"){
    print "No ".$workdir."/seq.hhr\n";
    goto PSSM;
}
undef %am_hhblits;
open(blast,$workdir."/seq.hhr");

$it=0;
while($line=<blast>){
    if($line=~/No \d+/){
	while($line=<blast>){
	    if($line=~/E-value=(\S+)\s+\S+\s+\S+\s+Identities=(\S+)\%/){
		$ev=$1;
		$id=$2;
		<blast>;
		if($ev<0.001){
		    $it++;
		    $ev_dim_hhblits{$it}=$ev;
		    $match=0;
		    $all_aligned=0;
		    while($line=<blast>){
			if($line=~/Q+\s+\S+\s*(\d+)\s+(\S+)\s+(\S+)/){
			    $i1=$1;
			    $seq1=$2;
			    <blast>;
			    <blast>;
			    <blast>;
			    <blast>=~/T+\s+\S+\s*(\d+)\s+(\S+)\s+(\S+)/;
			    $seq2=$2;
			    <blast>;
			    <blast>;
			    <blast>;
			    ###
			    $L=length $seq1;
			    $m1=$i1-1;
			    for($i=1;$i<=$L;$i++){
				$q1=substr($seq1,$i-1,1);
				$q2=substr($seq2,$i-1,1);
				$m1++ if($q1 ne '-');
				$all_aligned++ if($q1 ne '');
				if($q1 ne '-' && $q2 ne '-'){
				    #$log{$m1,$q2}++;  #without henikoff
				    $am_hhblits{$it,$m1}=$q2;  #with henikoff
				    if($q1 eq $q2){
					$match++;
				    }
				}
			    }
			    ##
			}else{
			    $id_self=$match/$all_aligned;
			    #print "$match    $all_aligned\n"; 
			    #print "$id       $id_self\n"; 
			    if($id_self>=0.98){
				for($i=1;$i<=$Lch;$i++){
				    $am_hhblits{$it,$i}='';
				}
				$it--;
			    }
			    goto pos3;
			}
		    }
		}
	      pos3:;
	    }
	}
    }
}
close(blast);

for($j=1;$j<=$it;$j++){
    for($i=1;$i<=$Lch;$i++){
	$a=$am_hhblits{$j,$i};
	if($a!~/\S/){
	    $am_hhblits{$j,$i}="-";
	}
    }
}
$it_hhblits=$it;

###############################################################
#make 'PSSM'
###############################################################

######## delete repeating sequences ------------>
PSSM:;
undef %am;
$it=0;
for($i=1;$i<=$it_blast;$i++){
    $it++;
    for($j=1;$j<=$Lch;$j++){
	$am{$it,$j}=$am_blast{$i,$j};
    }
    #$w{$it}=$w_blast{$i};
    #$w_all+=$w{$it};
}

if( !-e $workdir."/seq2.txt.query.out"){
    goto hhblits2;
}
for($i=1;$i<=$it_sift;$i++){
    $it++;
    $j=0;
    for($j=1;$j<=$it_blast;$j++){
	$k=0;
	for($k=1;$k<=$Lch;$k++){
	    if($am_blast{$j,$k} ne $am_sift{$i,$k}){
		last;
	    }
	}
	if($k == ($Lch+1)){
	    $it--;
	    last;
	}
    }
    if($j == ($it_blast+1)){
	for($z=1;$z<=$Lch;$z++){
	    $am{$it,$z}=$am_sift{$i,$z};
	}
	#$w{$it}=$w_sift{$i};
	#$w_all+=$w{$it};
    }
}
#print "$it  $it_blast   $it_sift\n";

hhblits2:;
if( !-e $workdir."/seq.hhr"){
    goto PSSM2;
}
$it_differ=$it;

for($i=1;$i<=$it_hhblits;$i++){
    $it++;
    $j=0;
    for($j=1;$j<=$it_differ;$j++){
	$k=0;
	for($k=1;$k<=$Lch;$k++){
	    if($am{$j,$k} ne $am_hhblits{$i,$k}){
		last;
	    }
	}
	if($k == ($Lch+1)){
	    $it--;
	    last;
	}
    }
    if($j == ($it_differ+1)){
	for($z=1;$z<=$Lch;$z++){
	    $am{$it,$z}=$am_hhblits{$i,$z};
	}
	#$w{$it}=$w_hhblits{$i};
	#$w_all+=$w{$it};
    }
}

PSSM2:;
##### with henikoff
####### Henikoff weight $wei{i_seq} ----------->
##### nA{A,i_pos}: number of times A appear at the position:
undef %nA; 
for($i=1;$i<=$Lch;$i++){
    for($j=1;$j<=$it;$j++){
	$nA{$am{$j,$i},$i}+=1;
    }
}
##### henikoff weight w(i)=sum of 1/rs:
for($i=1;$i<=$it;$i++){
    for($j=1;$j<=$Lch;$j++){
	####### r: number of different residues in j'th position:
	$r=0;
	foreach $A(@AA){
	    $r++ if($nA{$A,$j}>0);
	}
	$A=$am{$i,$j};
	$s2=$nA{$A,$j};
	$w1=1.0/($r*$s2);
	$w{$i}+=$w1;
    }
    $w_all+=$w{$i};
}

#### normalization of w(i)---------------->
for($i=1;$i<=$it;$i++){
    $w{$i}/=$w_all;
}
#^^^^^ Henikoff weight finished ^^^^^^^^^^^^^^^^^


######## initialize formula ------------>
########

#the total number of sequences in the alignment
$Nc=$it;            

#weighted frequence g_ja in hhblits alignment
undef %log;
for($i=1;$i<=$it;$i++){
    for($j=1;$j<=$Lch;$j++){
    	$A=$am{$i,$j};
    	$log{$j,$A}+=$w{$i};
    }
}
undef %close_log;
for($i=1;$i<=$Lch;$i++)
{
    foreach $A(@AA20)
    {
        $g_ja{$i,$A}=$log{$i,$A}+$log{$i,'-'}/20; 
    } 
}


#weighted frequence f_ja in pseu-docounts
%F_ja=BLOSUM($sequence,%g_ja);
#### normalization of f_ja:
for($i=1;$i<=$Lch;$i++)
{
    $norm=0;
    foreach $A(@AA20)
    {
        $norm+=$F_ja{$i,$A};
    }
    foreach $A(@AA20)
    {
        $f_ja{$i,$A}=$F_ja{$i,$A}/$norm;
    }   
}

#Bj is the total number of psedocounts Bj=exp(Dc); 
@Bj=Get_Bj($sequence,%g_ja);

#but we set Bj=0 at an invariant position
undef %nA; 
for($i=1;$i<=$Lch;$i++){
    for($j=1;$j<=$Nc;$j++){
    	$nA{$am{$j,$i},$i}+=1;
    }
}

for($j=1;$j<=$Lch;$j++){
       ####### r: number of different residues in j'th position:
    $r=0;
    foreach $A(@AA20){
	$r++ if($nA{$A,$j}>0);
    }
    $Bj[j]=0 if($r<2);
}


######## Position-Specific Probability Estimation p_ja------------>
for($j=1;$j<=$Lch;$j++){
    foreach $A(@AA20){
	$p_ja{$j,$A}=$Nc/($Nc+$Bj[$j])*$g_ja{$j,$A}+$Bj[$j]/($Nc+$Bj[$j])*$f_ja{$j,$A};
	#print $p_ja{$j,$A}," ";
    }
    #print "\n";
}

for($j=1;$j<=$Lch;$j++){
    foreach $A(@AA20){
	$p[$j]+=$p_ja{$j,$A};
    }
    #print "$p[$j]\n";
}
=pod
open(seq,">/nfs/amino-home/liquan/SequenceProfile/MSA/".$protein.".msa");
for($i=1;$i<=$Nc;$i++){
    for($j=1;$j<=$Lch;$j++){
	printf seq "$am{$i,$j}";
    }
    printf seq "\n";
}
close(seq);
=cut
open(seq,">".$workdir."/seq.pssm");
foreach $A(@AA20){
    printf seq "\t$A";
}
printf seq "\n";
for($j=1;$j<=$Lch;$j++){
    printf seq "$j   $seqQ{$j}   ";
    foreach $A(@AA20){
	printf seq "$p_ja{$j,$A} ";
    }
    printf seq "\n";
}
close(seq);
exit();


sub BLOSUM
{   
    my($s,%G_ja)=@_;
    my @sequence = split( //, $s );
    my $length=length $s;
    my $i;
    my $j;
    my $sum;
    my @words;
    my @b62;

    my %aaNum = (
        A => 0,
        R => 1,
        N => 2,
        D => 3,
        C => 4,
        Q => 5,
        E => 6,
        G => 7,
        H => 8,
        I => 9,
        L => 10,
        K => 11,
        M => 12,
        F => 13,
        P => 14,
        S => 15,
        T => 16,
        W => 17,
        Y => 18,
        V => 19,
    );
   
    my $blosum62 = <<BLOSUM;
#  BLOSUM Clustered Target Frequencies=qij
#  Blocks Database = /data/blocks_5.0/blocks.dat
#  Cluster Percentage: >= 62
   A      R      N      D      C      Q      E      G      H      I      L      K      M      F      P      S      T      W      Y      V
0.0215
0.0023 0.0178
0.0019 0.0020 0.0141
0.0022 0.0016 0.0037 0.0213
0.0016 0.0004 0.0004 0.0004 0.0119
0.0019 0.0025 0.0015 0.0016 0.0003 0.0073
0.0030 0.0027 0.0022 0.0049 0.0004 0.0035 0.0161
0.0058 0.0017 0.0029 0.0025 0.0008 0.0014 0.0019 0.0378
0.0011 0.0012 0.0014 0.0010 0.0002 0.0010 0.0014 0.0010 0.0093
0.0032 0.0012 0.0010 0.0012 0.0011 0.0009 0.0012 0.0014 0.0006 0.0184
0.0044 0.0024 0.0014 0.0015 0.0016 0.0016 0.0020 0.0021 0.0010 0.0114 0.0371
0.0033 0.0062 0.0024 0.0024 0.0005 0.0031 0.0041 0.0025 0.0012 0.0016 0.0025 0.0161
0.0013 0.0008 0.0005 0.0005 0.0004 0.0007 0.0007 0.0007 0.0004 0.0025 0.0049 0.0009 0.0040
0.0016 0.0009 0.0008 0.0008 0.0005 0.0005 0.0009 0.0012 0.0008 0.0030 0.0054 0.0009 0.0012 0.0183
0.0022 0.0010 0.0009 0.0012 0.0004 0.0008 0.0014 0.0014 0.0005 0.0010 0.0014 0.0016 0.0004 0.0005 0.0191
0.0063 0.0023 0.0031 0.0028 0.0010 0.0019 0.0030 0.0038 0.0011 0.0017 0.0024 0.0031 0.0009 0.0012 0.0017 0.0126
0.0037 0.0018 0.0022 0.0019 0.0009 0.0014 0.0020 0.0022 0.0007 0.0027 0.0033 0.0023 0.0010 0.0012 0.0014 0.0047 0.0125
0.0004 0.0003 0.0002 0.0002 0.0001 0.0002 0.0003 0.0004 0.0002 0.0004 0.0007 0.0003 0.0002 0.0008 0.0001 0.0003 0.0003 0.0065
0.0013 0.0009 0.0007 0.0006 0.0003 0.0007 0.0009 0.0008 0.0015 0.0014 0.0022 0.0010 0.0006 0.0042 0.0005 0.0010 0.0009 0.0009 0.0102
0.0051 0.0016 0.0012 0.0013 0.0014 0.0012 0.0017 0.0018 0.0006 0.0120 0.0095 0.0019 0.0023 0.0026 0.0012 0.0024 0.0036 0.0004 0.0015 0.0196
BLOSUM

    $i = 0;
    my @blosum62 = split( /\n/, $blosum62 );

    # read/build the blosum matrix
    foreach my $blosumline (@blosum62) {
	next if ( $blosumline !~ /^\d/ );
        chomp $blosumline;
        @words = split( /\s/, $blosumline );
	#print "$#words \n";
        for($j= 0;$j<=$#words;++$j ){
            $b62[$i][$j]=$words[$j];
            $b62[$j][$i]=$words[$j];
        }
        ++$i;
    }

    # normalize the blosum matrix so that each row sums to 1.0
    for ( $i = 0 ; $i < 20 ; ++$i ) {
        $sum = 0.0;

        for ( $j = 0 ; $j < 20 ; ++$j ) {
            $sum += $b62[$i][$j];
        }

        for ( $j = 0 ; $j < 20 ; ++$j ) {
            $b62[$i][$j] = ( $b62[$i][$j] / $sum );
        }
    }
    
    for($i=1;$i<=$length;$i++){
    	foreach $A(@AA20)
    	{
    		$F_ja{$i,$A}=$G_ja{$i,$A}*$b62[$aaNum{$sequence[$i]}][$aaNum{$A}]; 
    	}
    }
=pod
    for($i=1;$i<=$length;$i++)
    {
    	foreach $A(@AA20)
    	{
    		foreach $A2(@AA20)
    		{
    			$F_ja{$i,$A}+=$G_ja{$i,$A2}*$b62[$aaNum{$A2}][$aaNum{$A}]; 
				}
			}
		}
=cut
		return %F_ja;
}


sub Get_Bj
{   
    my($s,%G_ja)=@_;
    my @sequence = split( //, $s );
    my $length=length $s;
    my $i;
    my $j;
    my @words;
    my @b62;

    my %aaNum = (
        A => 0,
        R => 1,
        N => 2,
        D => 3,
        C => 4,
        Q => 5,
        E => 6,
        G => 7,
        H => 8,
        I => 9,
        L => 10,
        K => 11,
        M => 12,
        F => 13,
        P => 14,
        S => 15,
        T => 16,
        W => 17,
        Y => 18,
        V => 19,
    );
   
    my $blosum62 = <<BLOSUM;
#  BLOSUM Clustered Target Frequencies=qij
#  Blocks Database = /data/blocks_5.0/blocks.dat
#  Cluster Percentage: >= 62
   A      R      N      D      C      Q      E      G      H      I      L      K      M      F      P      S      T      W      Y      V
0.0215
0.0023 0.0178
0.0019 0.0020 0.0141
0.0022 0.0016 0.0037 0.0213
0.0016 0.0004 0.0004 0.0004 0.0119
0.0019 0.0025 0.0015 0.0016 0.0003 0.0073
0.0030 0.0027 0.0022 0.0049 0.0004 0.0035 0.0161
0.0058 0.0017 0.0029 0.0025 0.0008 0.0014 0.0019 0.0378
0.0011 0.0012 0.0014 0.0010 0.0002 0.0010 0.0014 0.0010 0.0093
0.0032 0.0012 0.0010 0.0012 0.0011 0.0009 0.0012 0.0014 0.0006 0.0184
0.0044 0.0024 0.0014 0.0015 0.0016 0.0016 0.0020 0.0021 0.0010 0.0114 0.0371
0.0033 0.0062 0.0024 0.0024 0.0005 0.0031 0.0041 0.0025 0.0012 0.0016 0.0025 0.0161
0.0013 0.0008 0.0005 0.0005 0.0004 0.0007 0.0007 0.0007 0.0004 0.0025 0.0049 0.0009 0.0040
0.0016 0.0009 0.0008 0.0008 0.0005 0.0005 0.0009 0.0012 0.0008 0.0030 0.0054 0.0009 0.0012 0.0183
0.0022 0.0010 0.0009 0.0012 0.0004 0.0008 0.0014 0.0014 0.0005 0.0010 0.0014 0.0016 0.0004 0.0005 0.0191
0.0063 0.0023 0.0031 0.0028 0.0010 0.0019 0.0030 0.0038 0.0011 0.0017 0.0024 0.0031 0.0009 0.0012 0.0017 0.0126
0.0037 0.0018 0.0022 0.0019 0.0009 0.0014 0.0020 0.0022 0.0007 0.0027 0.0033 0.0023 0.0010 0.0012 0.0014 0.0047 0.0125
0.0004 0.0003 0.0002 0.0002 0.0001 0.0002 0.0003 0.0004 0.0002 0.0004 0.0007 0.0003 0.0002 0.0008 0.0001 0.0003 0.0003 0.0065
0.0013 0.0009 0.0007 0.0006 0.0003 0.0007 0.0009 0.0008 0.0015 0.0014 0.0022 0.0010 0.0006 0.0042 0.0005 0.0010 0.0009 0.0009 0.0102
0.0051 0.0016 0.0012 0.0013 0.0014 0.0012 0.0017 0.0018 0.0006 0.0120 0.0095 0.0019 0.0023 0.0026 0.0012 0.0024 0.0036 0.0004 0.0015 0.0196
BLOSUM

    $i = 0;
    my @blosum62 = split( /\n/, $blosum62 );

    # read/build the blosum matrix
    foreach my $blosumline (@blosum62) {
	next if ( $blosumline !~ /^\d/ );
        chomp $blosumline;
        @words = split( /\s/, $blosumline );
	#print "$#words \n";
        for($j= 0;$j<=$#words;++$j ){
            $b62[$i][$j]=$words[$j];
            $b62[$j][$i]=$words[$j];
        }
        ++$i;
    }

    #find reference amino acid at each position: max(g_ja)
    undef my %order;
    my @Reference;
    for($i=1;$i<=$length;$i++){
	$Reference[$i]=$AA20[1];
	foreach $A(@AA20)
	{
	    if($G_ja{$i,$Reference[$i]}<$G_ja{$i,$A}){
		$Reference[$i]=$A;
	    }
	}
	$order{$i,$Reference[$i]}=1;
    }

    #%order is the rank that amino acid a has in an ordered list from the highest to lowest score from a substitution matrix for the reference amino acid
    for($i=1;$i<=$length;$i++){
	foreach $A(@AA20)
	{
	    if($A ne $Reference[$i])
	    {
		my $num=0;
		foreach $A2(@AA20)
		{
		    if($A2 ne $Reference[$i])
		    {
			if($b62[$aaNum{$Reference[$i]}][$aaNum{$A}]<$b62[$aaNum{$Reference[$i]}][$aaNum{$A2}])
			{
			    $num++;
			}
			#if($b62[$aaNum{$Reference[$i]}][$aaNum{$A}]==$b62[$aaNum{$Reference[$i]}][$aaNum{$A2}])
			#{
			   # $num++ if($G_ja{$i,$A}<$G_ja{$i,$A2});   
			#}
		    }
		}
		$order{$i,$A}=$num+2;
	    }
	}
    }
    for($i=1;$i<=$length;$i++){
	foreach $A(@AA20)
	{
	    #Dc is a weighted diversity measure
	    $Dc[$i]+=$order{$i,$A}*$G_ja{$i,$A};
	}
	$B_c[$i]=exp($Dc[$i]);
    }
    return @B_c;
}
