#!/usr/bin/env python
import sys,os,math

INPUT=sys.argv[1]+" A "+sys.argv[2]+" "+sys.argv[3]+" "+sys.argv[4]
OUTPUT=sys.argv[5]
FEATUREHOME=sys.argv[6]

codeToVal = {"G": 78.7, "A": 110.2, "V": 153.7,
		"L": 183.1, "I": 185.0, "M": 200.1, "F": 200.7,
                "W": 240.5, "P": 141.9, "S": 117.2, "T": 138.7, 
                "C": 140.4, "Y": 213.7, "N": 146.4, "Q": 178.6, 
                "D": 144.1, "E": 174.7, "K": 205.7, "R": 229.0,
                "H": 181.9}

amino_frq={'C':0.01666,'M':0.02376,'F':0.04096,'I':0.05817,'L':0.09427,'V':0.06587,'W':0.01236,'Y':0.03186,'A':0.07587,'G':0.06847,'T':0.05677,'S':0.07127,
     'Q':0.03976,
     'N':0.04456,
     'E':0.06377,
     'D':0.05287,
     'H':0.02246,
     'R':0.05166,
     'K':0.05957,
     'P':0.04906
     }
AA=[
    'C',
    'M',
    'F',
    'I',
    'L',
    'V',
    'W',
    'Y',
    'A',
    'G',
    'T',
    'S',
    'Q',
    'N',
    'E',
    'D',
    'H',
    'R',
    'K',
    'P']
amino={'C':1,'M':2,'F':3,'I':4,'L':5,'V':6,'W':7,'Y':8,'A':9,'G':10,'T':11,'S':12,
     'Q':13,
     'N':14,
     'E':15,
     'D':16,
     'H':17,
     'R':18,
     'K':19,
     'P':20
     }
V_residue={
    'A':2.30,
    'C':2.50,
    'D':2.80,
    'E':3.05,
    'F':3.40,
    'G':1.90,
    'H':3.10,
    'I':3.09,
    'K':3.15,
    'L':3.15,
    'M':3.10,
    'N':2.85,
    'P':2.80,
    'Q':3.05,
    'R':3.16,
    'S':2.40,
    'T':2.80,
    'V':2.91,
    'W':3.60,
    'Y':3.45
     }

Phar_residue={
    'A':[2,2,3,1,4,0,0,0],
    'C':[3,2,3,1,6,0,0,1],
    'D':[3,4,6,1,8,0,0,1],
    'E':[3,4,6,1,8,0,0,2],
    'F':[2,2,3,1,4,6,6,2],
    'G':[2,2,3,1,4,0,0,0],
    'H':[4,3,3,6,4,4,0,1],
    'I':[2,2,3,1,4,0,0,2],
    'K':[3,2,3,2,4,0,0,2],
    'L':[2,2,3,1,4,0,3,2],
    'M':[2,2,3,1,4,0,0,2],
    'N':[3,3,3,1,4,0,0,1],
    'P':[2,2,3,1,4,0,0,0],
    'Q':[3,3,3,1,4,0,0,2],
    'R':[5,2,3,5,4,0,0,2],
    'S':[3,3,3,1,4,0,0,0],
    'T':[3,3,3,1,4,0,0,0],
    'V':[2,2,3,1,4,0,3,1],
    'W':[3,2,3,1,4,11,6,3],
    'Y':[3,3,3,1,4,6,6,2]
     }

Molecular_weight={
    'A':89.09,
    'C':121.16,
    'D':133.1,
    'E':147.13,
    'F':165.19,
    'G':75.07,
    'H':155.16,
    'I':131.18,
    'K':146.19,
    'L':131.18,
    'M':149.21,
    'N':132.12,
    'P':115.13,
    'Q':146.15,
    'R':174.2,
    'S':105.09,
    'T':119.12,
    'V':117.15,
    'W':204.23,
    'Y':181.19
     }

Hydrophobicity={
    'A':-0.2,
    'C':0.4,
    'D':11.5,
    'E':9.5,
    'F':-1.5,
    'G':0,
    'H':6.8,
    'I':-2.6,
    'K':7.4,
    'L':-2.6,
    'M':1.3,
    'N':7.7,
    'P':2.8,
    'Q':5.4,
    'R':19.8,
    'S':0.8,
    'T':1.1,
    'V':-1.2,
    'W':1.3,
    'Y':4.3
     }

Isoelectric_point={
    'A':6.01,
    'C':5.07,
    'D':2.77,
    'E':3.22,
    'F':5.48,
    'G':5.97,
    'H':7.59,
    'I':6.02,
    'K':9.74,
    'L':5.98,
    'M':5.74,
    'N':5.41,
    'P':6.48,
    'Q':5.65,
    'R':10.76,
    'S':5.68,
    'T':5.87,
    'V':5.97,
    'W':5.89,
    'Y':5.66
     }

out = open(OUTPUT+'/Features.txt','w')
#f = open(INPUT,'r')
#f_line = f.readline()
f_line = INPUT
while f_line:
    volumns = f_line.strip().split()
    pdb_name = volumns[0]
    res_num = int(volumns[2])
    sequence_name = pdb_name
    wild_type = volumns[3]
    mutant_type = volumns[4]
    sidechain = pdb_name+str(res_num)+mutant_type
    
    new_line = ''

    ############################################
    #read sequence information
    ############################################
    new_line = new_line + str(amino[wild_type])+' '+str(amino[mutant_type])+' '
    
    dV = V_residue[mutant_type]-V_residue[wild_type]
    new_line = new_line + str(dV) + ' '+str(V_residue[wild_type])+' '

    dW =Molecular_weight[mutant_type] - Molecular_weight[wild_type]
    new_line = new_line + str(dW) + ' '+str(Molecular_weight[wild_type])+' '

    dH = Hydrophobicity[mutant_type] - Hydrophobicity[wild_type]
    new_line = new_line + str(dH) + ' '+str(Hydrophobicity[wild_type])+' '
    
    dI = Isoelectric_point[mutant_type] - Isoelectric_point[wild_type]
    new_line = new_line + str(dI) + ' '+str(Isoelectric_point[wild_type])+' '

    ############################################
    #read MSA information
    ############################################
    #######read PSSM-------------------->
    pssm_path = FEATUREHOME + '/seq.pssm'
    f_pssm = open(pssm_path,'r')
    f_pssm_line = f_pssm.readline()
    for i in range(0,res_num):
        f_pssm_line = f_pssm.readline()
    
    f_pssm_line = f_pssm_line.strip().split()
    for i in range(2,22):
        if float(f_pssm_line[i]) == 0.0:
        	new_line = new_line+str(round(0.00001/amino_frq[f_pssm_line[1]],4))+' '
        else:
            new_line = new_line+str(round(float(f_pssm_line[i])/amino_frq[f_pssm_line[1]],4))+' '        	
    f_pssm.close

    
    #######read Rc-------------------->
    f_pssm = open(pssm_path,'r')
    f_pssm_line = f_pssm.readline()
    for i in range(0,res_num):
        f_pssm_line = f_pssm.readline()
    
    f_pssm_line = f_pssm_line.strip().split()
    sum_aa = 0.0
    for i in range(2,22):
        if float(f_pssm_line[i]) == 0.0:
            sum_aa += 0.0
        else:
            sum_aa += -float(f_pssm_line[i])*math.log(float(f_pssm_line[i]),2)
    Rc = round(math.log(20,2)-sum_aa,2)
    new_line = new_line+str(Rc)+' '
    f_pssm.close

    #######read predicted structure information based on sequence
    
    #######read secondary structure(frequence)-------------------->
    secondary_path = FEATUREHOME + '/seq.ss'
    f_secondary = open(secondary_path,'r')
    f_secondary_line = f_secondary.readline()
    f_secondary_line = f_secondary.readline()
    while(f_secondary_line):
        temp = f_secondary_line.strip().split()
        if temp[0] == str(res_num):
            new_line = new_line+temp[3]+' '+temp[4]+' '+temp[5]+' '
            break
        f_secondary_line = f_secondary.readline()
    f_secondary.close

    #######read SA-------------------->
    SA_path = FEATUREHOME + '/seq.exp.sa'
    f_SA = open(SA_path,'r')
    f_SA_line = f_SA.readline()
    f_SA_line = f_SA.readline()
    while(f_SA_line):
        #print f_SA_line
        temp = f_SA_line.strip().split()
        if temp[0] == str(res_num):
            new_line = new_line+temp[1]+' '
            break
        f_SA_line = f_SA.readline()
    f_SA.close

    
    #######read phi-------------------->
    phi_path = FEATUREHOME + '/seq.svr.phi'
    f_phi = open(phi_path,'r')
    f_phi_line = f_phi.readline()
    f_phi_line = f_phi.readline()
    while(f_phi_line):
        temp = f_phi_line.strip().split()
        if temp[0] == str(res_num):
            new_line = new_line+temp[1]+' '
            break
        f_phi_line = f_phi.readline()
    f_phi.close


    #######read psi-------------------->
    psi_path = FEATUREHOME + '/seq.svr.psi'
    f_psi = open(psi_path,'r')
    f_psi_line = f_psi.readline()
    f_psi_line = f_psi.readline()
    while(f_psi_line):
        temp = f_psi_line.strip().split()
        if temp[0] == str(res_num):
            new_line = new_line+temp[1]+' '
            break
        f_psi_line = f_psi.readline()
    f_psi.close


    #######read Template profile based on TMscore and BLOSUM-------------------->
    potential_path = FEATUREHOME
    f_potential = open(potential_path+'/seq_wt.we','r')
    f_potential_line = f_potential.readline()
    f_potential_line = f_potential.readline()
    while(f_potential_line):
        temp_wt = f_potential_line.strip().split()
        if (temp_wt[0]== '3') and (temp_wt[1] == str(res_num)) and (temp_wt[2] == mutant_type):
            break
        f_potential_line = f_potential.readline()
    f_potential.close
    
    f_potential = open(potential_path+'/seq_mt.we','r')
    f_potential_line = f_potential.readline()
    f_potential_line = f_potential.readline()
    while(f_potential_line):
        temp_mt = f_potential_line.strip().split()
        if (temp_mt[0]== '3') and (temp_mt[1] == str(res_num)) and (temp_mt[2] == mutant_type):
            break
        f_potential_line = f_potential.readline()
    f_potential.close
    
    for d in range(3,4):
        if temp_wt[d] == '-':
            new_line = new_line + '-10 '
            continue
        new_line = new_line + str(round(float(temp_wt[d]),4))+' '
    
    for d in range(3,4):
        if temp_mt[d] == '-':
            new_line = new_line + '-10 '
            continue
        new_line = new_line + str(round(float(temp_mt[d]),4))+' '   

    ############################################
    #read ITASSER-models profile
    ############################################

    #######read RW and DFIRE-------------------->
    WR_path = FEATUREHOME + '/RW_DFIRE.en'
    f_WR = open(WR_path,'r')
    f_WR_line = f_WR.readline()
    while(f_WR_line):
        temp_WR = f_WR_line.strip().split()
        if (temp_WR[0]== '1') and (temp_WR[1] == str(res_num)) and (temp_WR[2] == mutant_type):
            break
        f_WR_line = f_WR.readline()
    f_WR.close

    for d in range(3,17):
        if temp_WR[d] == '-':
            new_line = new_line + '-10 '
            continue
        new_line = new_line + str(round(float(temp_WR[d]),4))+' '



    #######read Amber.dat (1) Decomp-------------------->
    Amber_path = FEATUREHOME
    wt_amber_log = 0
    if (os.path.isfile(Amber_path+'/'+sequence_name+'_DECOMP_MMPBSA.dat')):
        f_amber = open(Amber_path+'/'+sequence_name+'_DECOMP_MMPBSA.dat','r')
        f_amber_line = f_amber.readline()
        while(f_amber_line):
            if(f_amber_line.find('Total Energy Decomposition:') != -1):
                f_amber_line = f_amber.readline()
                f_amber_line = f_amber.readline()
                f_amber_line = f_amber.readline()
                while(f_amber_line):
                    temp = f_amber_line.strip().split()
                    if(temp[1]==str(res_num)):
                        temp_wt = [temp[3],temp[7],temp[11],temp[15],temp[19],temp[23]]
                        wt_amber_log = 1
                        break
                    f_amber_line = f_amber.readline()
            if(wt_amber_log ==1):
                break
            f_amber_line = f_amber.readline()
        f_amber.close

    mt_amber_log = 0
    if (os.path.isfile(Amber_path+'/'+sidechain+'_DECOMP_MMPBSA.dat')):
        f_amber = open(Amber_path+'/'+sidechain+'_DECOMP_MMPBSA.dat','r')
        f_amber_line = f_amber.readline()
        while(f_amber_line):
            if(f_amber_line.find('Total Energy Decomposition:') != -1):
                f_amber_line = f_amber.readline()
                f_amber_line = f_amber.readline()
                f_amber_line = f_amber.readline()
                while(f_amber_line):
                    temp = f_amber_line.strip().split()
                    if(temp[1]==str(res_num)):
                        temp_mt = [temp[3],temp[7],temp[11],temp[15],temp[19],temp[23]]
                        mt_amber_log = 1
                        break
                    f_amber_line = f_amber.readline()
            if(mt_amber_log ==1):
                break
            f_amber_line = f_amber.readline()
        f_amber.close

    
    if(wt_amber_log == 0):
        new_line = new_line + ' '.join(['100','100','100','100','100','100'])+' '
    else:
        for d in range(0,len(temp_wt)):
            new_line = new_line + str(float(temp_wt[d]))+' '
    
    if(mt_amber_log == 0):
        new_line = new_line + ' '.join(['100','100','100','100','100','100'])+' '
    else:
        for d in range(0,len(temp_mt)):
            new_line = new_line + str(float(temp_mt[d]))+' '
    
    
    #######read Amber.dat (2) TOTAL-------------------->
    wt_amber_log = 0
    if (os.path.isfile(Amber_path+'/'+sequence_name+'_RESULTS_MMPBSA.dat')):
        f_amber = open(Amber_path+'/'+sequence_name+'_RESULTS_MMPBSA.dat','r')
        f_amber_line = f_amber.readline()
        
        temp_wt = []
        while(f_amber_line):
            if(f_amber_line.find('Energy Component') != -1):
                f_amber_line = f_amber.readline()
                f_amber_line = f_amber.readline()
                while(f_amber_line):
                    temp = f_amber_line.strip().split()
                    if(f_amber_line.strip()!=''):
                        temp_wt.append(temp[-3])
                        if(temp[0]=='TOTAL'):
                            wt_amber_log =1
                            break
                    f_amber_line = f_amber.readline()
            if(wt_amber_log ==1):
                break
            f_amber_line = f_amber.readline()
        f_amber.close

    mt_amber_log = 0
    if (os.path.isfile(Amber_path+'/'+sidechain+'_RESULTS_MMPBSA.dat')):
        f_amber = open(Amber_path+'/'+sidechain+'_RESULTS_MMPBSA.dat','r')
        f_amber_line = f_amber.readline()
        
        temp_mt = []
        while(f_amber_line):
            if(f_amber_line.find('Energy Component') != -1):
                f_amber_line = f_amber.readline()
                f_amber_line = f_amber.readline()
                while(f_amber_line):
                    temp = f_amber_line.strip().split()
                    if(f_amber_line.strip()!=''):
                        temp_mt.append(temp[-3])
                        if(temp[0]=='TOTAL'):
                            mt_amber_log =1
                            break
                    f_amber_line = f_amber.readline()
            if(mt_amber_log ==1):
                break
            f_amber_line = f_amber.readline()
        f_amber.close

    
    if(wt_amber_log == 0):
        new_line = new_line+' '.join(['100','100','100','100','100','100','100','100','100','100','100','100'])+' '
    else:
        for d in range(0,len(temp_wt)):
            new_line = new_line + str(float(temp_wt[d]))+' '
    
    if(mt_amber_log == 0):
        new_line = new_line+' '.join(['100','100','100','100','100','100','100','100','100','100','100','100'])+' '
    else:
        for d in range(0,len(temp_mt)):
            new_line = new_line + str(float(temp_mt[d]))+' '
    

    #######read FoldX energy-------------------->
    Foldx_path = FEATUREHOME
    f_foldx = open(Foldx_path+'/'+sequence_name+'.stability','r')
    f_foldx_line = f_foldx.readline()
    wt_foldx_log = 0
    while(f_foldx_line):
	temp = f_foldx_line.strip().split()
        if(len(temp) > 21):
            temp_wt = [temp[1],temp[2],temp[3],temp[4],temp[5],temp[6],temp[7],temp[8],temp[9],temp[10],temp[14],temp[15],temp[16],temp[21]]
            wt_foldx_log = 1
            break
        f_foldx_line = f_foldx.readline()
    f_foldx.close
    
    f_foldx = open(Foldx_path+'/'+sidechain+'.stability','r')
    f_foldx_line = f_foldx.readline()
    mt_foldx_log = 0
    while(f_foldx_line):
	temp = f_foldx_line.strip().split()
        if(len(temp)>21):
            temp_mt = [temp[1],temp[2],temp[3],temp[4],temp[5],temp[6],temp[7],temp[8],temp[9],temp[10],temp[14],temp[15],temp[16],temp[21]]
            mt_foldx_log = 1
            break
        f_foldx_line = f_foldx.readline()
    f_foldx.close
    
    if(wt_foldx_log == 0):
        new_line = new_line + ' '.join(['100','100','100','100','100','100','100','100','100','100','100','100','100','100'])+' '
    else:
        for d in range(0,len(temp_wt)):
            new_line = new_line + str(float(temp_wt[d]))+' '
    
    if(mt_foldx_log == 0):
        new_line = new_line + ' '.join(['100','100','100','100','100','100','100','100','100','100','100','100','100','100'])+' '
    else:
        for d in range(0,len(temp_mt)):
            new_line = new_line + str(float(temp_mt[d]))+' '

    out.write(new_line+'\n')
    exit()
    #f_line = f.readline()
out.close
f.close   
