#!/usr/bin/perl

use Math::Trig;
use File::Copy;

#### USER INPUT
my $list          =$ARGV[0];
my $OUTPUT        =$ARGV[1];
my $pdbLibrary_mt    = $ARGV[2];
my $foldx =$ARGV[3];


## PROGRAMS and files
`mkdir $OUTPUT`;
`mkdir $OUTPUT/temp_FoldX_mt`;
## FolderNames and OUTPUT file for notes
=pod
open (FH1, "<$list") or die "YOU DIDNT OPEN LIST";
my @array=<FH1>;
chomp @array;
close (FH1);
=cut
my @array=($list);
##make error file
open (err_foldx,">$OUTPUT/FoldX_energy_err_mt") or die "YOU DIDNT OPEN ERROR FILE";

chdir "$OUTPUT/temp_FoldX_mt";

foreach my $line(@array){
    chomp($line);
    #$line=~s/^ +//;
    #my @items=split(/\s+/,$line);
    #my $pdb = $items[0];
    #my $pdbFile = "$pdb$items[2]$items[4].pdb";
    my $pdbFile = "$line.pdb";
    
    #-------------------------------------------->    
    my $list_in = <<LIST;
$pdbFile
LIST

    open (list_file, ">list.txt") or die "YOU DIDNT OPEN LIST";
    printf list_file $list_in;
    close(list_file);
    
    #-------------------------------------------->    
    my $run_in = <<RUN;
pdb-list=list.txt
output-file=Stability
temperature=298
pH=7
ionStrength=0.050
water=-CRYSTAL
vdwDesign=2
outPDB=false
pdbHydrogens=false
RUN

    open (run_file, ">run.txt") or die "YOU DIDNT OPEN LIST";
    printf run_file $run_in;
    close(run_file);
    copy ("$foldx/rotabase.txt", "$OUTPUT/temp_FoldX_mt/rotabase.txt");
    copy ("$pdbLibrary_mt/$pdbFile", "$OUTPUT/temp_FoldX_mt/$pdbFile");

    `$foldx/foldx -c Stability -f run.txt`;

    #-------------------------------------------->
    unless(-e "$OUTPUT/temp_FoldX_mt/Stability_ST.fxout"){
	printf err_mt "$pdbFile\n";
	next;
    }
    copy ("$OUTPUT/temp_FoldX_mt/Stability_ST.fxout", "$OUTPUT/$line.stability");
    #`rm  $OUTPUT/temp_FoldX_mt/*`;
}

close(err_mt);
exit();
