#!/usr/bin/perl

use Math::Trig;
use File::Copy;

#### USER INPUT
my $pdb          =$ARGV[0];
my $OUTPUT        =$ARGV[1];
my $pdbLibrary_wt    = $ARGV[2];
my $foldx =$ARGV[3];

## PROGRAMS and files
`mkdir $OUTPUT`;
`mkdir $OUTPUT/temp_FoldX`;

##make error file
open (err_foldx,">$OUTPUT/FoldX_energy_err") or die "YOU DIDNT OPEN ERROR FILE";

chdir "$OUTPUT/temp_FoldX";


my $pdbFile = "$pdb.pdb";
    
    
#-------------------------------------------->    
my $list_in = <<LIST;
$pdbFile
LIST

    open (list_file, ">list.txt") or die "YOU DIDNT OPEN LIST";
    printf list_file $list_in;
    close(list_file);
    
#-------------------------------------------->    
my $run_in = <<RUN;
pdb-list=list.txt
output-file=Stability
temperature=298
pH=7
ionStrength=0.050
water=-CRYSTAL
vdwDesign=2
outPDB=false
pdbHydrogens=false
RUN

open (run_file, ">run.txt") or die "YOU DIDNT OPEN LIST";
printf run_file $run_in;
close(run_file);
    
copy ("$foldx/rotabase.txt", "$OUTPUT/temp_FoldX/rotabase.txt");
copy ("$pdbLibrary_wt/$pdbFile", "$OUTPUT/temp_FoldX/$pdbFile");

#`$foldx/foldx3b6 -runfile run.txt`;
`$foldx/foldx -c Stability -f run.txt`;

#-------------------------------------------->
unless(-e "$OUTPUT/temp_FoldX/Stability_ST.fxout"){
    printf err_mt "$pdbFile\n";
}
    
copy ("$OUTPUT/temp_FoldX/Stability_ST.fxout", "$OUTPUT/$pdb.stability");
`rm  $OUTPUT/temp_FoldX/*`;

close(err_mt);
exit();
