#!/usr/bin/perl

use Math::Trig;
use File::Copy;

#### USER INPUT
my $pdb          =@ARGV[0];
my $OUTPUT        =@ARGV[1];
my $wild = @ARGV[2];
my $position = @ARGV[3];
my $mutant = @ARGV[4];

## PROGRAMS and files
my $workhome = @ARGV[5];
my $pdbLibrary_wt    = "$workhome/ScwrlPDB_wt";
my $pdbLibrary_mt    = "$workhome/ScwrlPDB_mt";
my $runRW = @ARGV[6];
my $runRWplus = @ARGV[7];
my $runDFIRE = @ARGV[8];
`cp $runRW/calRW $workhome/`;
`cp $runRW/data.dat $workhome/`;
`cp $runRWplus/calRWplus $workhome/`;
`cp $runRWplus/rw.dat $workhome/`;
`cp $runRWplus/scb.dat $workhome/`;
`cp $runDFIRE/dDFIRE $workhome/`;
`cp $runDFIRE/amino.dat $workhome/`;
`cp $runDFIRE/dfire.1 $workhome/`;
chdir "$workhome";
`mkdir $OUTPUT`;
`mkdir $OUTPUT/temp_RW`;
#make error file
open (err_RW,">$OUTPUT/RW_err") or die "YOU DIDNT OPEN ERROR FILE";


my $pdbFile = "$pdb.pdb";
#print "$pdbFile\n";

$RW_wt='';
$RWplus_wt='';
$Dfire1_wt='';
$Dfire2_wt='';
$Dfire3_wt='';
$Dfire4_wt='';
$Dfire5_wt='';
    
#chdir "/nfs/amino-home/liquan/RW/calRW";
$output=`$workhome/calRW $pdbLibrary_wt/$pdbFile`;
if($output=~/RW potential =\s*(\S+)\s*kcal\/mol/){
    $RW_wt = $1;
    print "$output";
}
else{
    $RW_wt = '-';
    printf err_RW "$s modify$i.pdb $output";
}

#chdir "/nfs/amino-home/liquan/RW/calRWplus";
$output=`$workhome/calRWplus $pdbLibrary_wt/$pdbFile`;
if($output=~/RW potential =\s*(\S+)\s*kcal\/mol/){
    $RWplus_wt = $1;
    print "$output";
}
else{
    $RWplus_wt = '-';
    printf err_RW "$s modify$i.pdb $output";
}

#chdir "/nfs/amino-home/liquan/dDFIRE1.1-bin";
$output=`$workhome/dDFIRE $pdbLibrary_wt/$pdbFile`;
if($output=~/$pdbFile:\s*(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/){
    $Dfire1_wt = $1;
    $Dfire2_wt = $2;
    $Dfire3_wt = $3;
    $Dfire4_wt = $4;
    $Dfire5_wt = $5;
    print "$output";
}
else{
    $Dfire1_wt= '-';
    $Dfire2_wt = '-';
    $Dfire3_wt = '-';
    $Dfire4_wt = '-';
    $Dfire5_wt = '-';
    printf err_RW "$s $pdbLibrary_wt/$pdbFile $output";
}

$mut_num=0;
%mutant_type={};
%pos_mut={};
$mut_num++;
$wild_type{$mut_num} = $wild;
$pos_mut{$mut_num} = int($position);
$mutant_type{$mut_num} = $mutant;


    
%RW={};
%RWplus={};
%Dfire1={};
%Dfire2={};
%Dfire3={};
%Dfire4={};
%Dfire5={};

for($i=1;$i<=$mut_num;$i++){
    #$out="$OUTPUT/out_$pos_mut{$i}$mutant_type{$i}";
    $mtPDB="$pdb$pos_mut{$i}$mutant_type{$i}.pdb";
	
    #chdir "/nfs/amino-home/liquan/RW/calRW";
    $output=`$workhome/calRW $pdbLibrary_mt/$mtPDB`;
    if($output=~/RW potential =\s*(\S+)\s*kcal\/mol/){
	$RW{$i} = $1;
	print "$output";
    }
    else{
	$RW{$i} = '-';
	printf err_RW "$s modify$i.pdb $output";
    }

    #chdir "/nfs/amino-home/liquan/RW/calRWplus";
    $output=`$workhome/calRWplus $pdbLibrary_mt/$mtPDB`;
    if($output=~/RW potential =\s*(\S+)\s*kcal\/mol/){
	$RWplus{$i} = $1;
	print "$output";
    }
    else{
	$RWplus{$i} = '-';
	printf err_RW "$s modify$i.pdb $output";
    }

    #chdir "/nfs/amino-home/liquan/dDFIRE1.1-bin";
    $output=`$workhome/dDFIRE $pdbLibrary_mt/$mtPDB`;
    if($output=~/$mtPDB:\s*(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/){
	$Dfire1{$i} = $1;
	$Dfire2{$i} = $2;
	$Dfire3{$i} = $3;
	$Dfire4{$i} = $4;
	$Dfire5{$i} = $5;
	print "$output";
    }
    else{
	$Dfire1{$i} = '-';
	$Dfire2{$i} = '-';
	$Dfire3{$i} = '-';
	$Dfire4{$i} = '-';
	$Dfire5{$i} = '-';
	printf err_RW "$s modify$i.pdb $output";
    }

}

%RW_wt={};
%RWplus_wt={};
%Dfire1_wt={};
%Dfire2_wt={};
%Dfire3_wt={};
%Dfire4_wt={};
%Dfire5_wt={};
#---------------print---------------------->
#chdir '/nfs/amino-home/liquan/StructureProfile/ITASSER_models/temp_RW';
open(ew,">$OUTPUT/$pdb.we");

for($i=1;$i<=$mut_num;$i++){
    printf ew "1 %5s %3s  ", $pos_mut{$i},$mutant_type{$i};
    printf ew "%10f %10f %10f %10f %10f %10f %10f %10f %10f %10f %10f %10f %10f %10f", $RW_wt,$RWplus_wt,$Dfire1_wt,$Dfire2_wt,$Dfire3_wt,$Dfire4_wt,$Dfire5_wt, $RW{$i},$RWplus{$i},$Dfire1{$i},$Dfire2{$i},$Dfire3{$i},$Dfire4{$i},$Dfire5{$i};
    printf ew "\n";
}
close(ew);

#copy ("$pdb.we", "$OUTPUT/$pdb.we");
#`rm  ./*`;


close(err_RW);
exit();
