#!/usr/bin/perl
#PBS -e /nfs/amino-home/liquan/RUN_TASSER/version_2014_09_25/S350/record/err_mkres_1_1aj3A
#PBS -o /nfs/amino-home/liquan/RUN_TASSER/version_2014_09_25/S350/record/out_mkres_1_1aj3A
#PBS -l walltime=0:20:00
use Math::Trig;
use File::Copy;

############################################################
$o="";
#$s="1aj3A";
$datadir="@ARGV[0]";
$wild=@ARGV[1];
$position=@ARGV[2];
$mutant=@ARGV[3];
#$initall="init_all.dat"; #init_all$o.dat
$input="@ARGV[4]";
$initall="@ARGV[4]/init.dat";
#$initall2="init_all2.dat";
$librarydir=@ARGV[5]; #$lib
$i_tasser=@ARGV[6];
$dssp=@ARGV[7];


####### sort template ##########
$sort="no";
$n_qua_sort=5; #number of qua closc for sorting
$n_ros_sort=2; #number of ros closc for sorting
$n_ita_sort=0; #number of ita closc for sorting

################# directories #############################
#$random=int(rand()*10000000000);
#*******$work_dir="/tmp/$random";
#$work_dir="/nfs/amino-home/liquan/RUN_TASSER/version_2014_09_25_2/qlj_test/$random";
#$work_dir="/nfs/amino-home/liquan/TemplateProfile_S2648/$random";
$work_dir=$datadir;
`/bin/mkdir -p $work_dir`;
#$work_dir="/tmp/yzhang/$tag";
#chdir "$work_dir";
`/bin/rm -f $work_dir/*`;

#`/bin/mkdir -p $datadir`;
#`/bin/rm -fr $datadir/*`;

############################################################

######<add
%ts=(
     'GLY'=>'G',
     'ALA'=>'A',
     'VAL'=>'V',
     'LEU'=>'L',
     'ILE'=>'I',
     'SER'=>'S',
     'THR'=>'T',
     'CYS'=>'C',
     'MET'=>'M',
     'PRO'=>'P',
     'ASP'=>'D',
     'ASN'=>'N',
     'GLU'=>'E',
     'GLN'=>'Q',
     'LYS'=>'K',
     'ARG'=>'R',
     'HIS'=>'H',
     'PHE'=>'F',
     'TYR'=>'Y',
     'TRP'=>'W',

     'ASX'=>'B',
     'GLX'=>'Z',
     'UNK'=>'X',

     'G'=>'GLY',
     'A'=>'ALA',
     'V'=>'VAL',
     'L'=>'LEU',
     'I'=>'ILE',
     'S'=>'SER',
     'T'=>'THR',
     'C'=>'CYS',
     'M'=>'MET',
     'P'=>'PRO',
     'D'=>'ASP',
     'N'=>'ASN',
     'E'=>'GLU',
     'Q'=>'GLN',
     'K'=>'LYS',
     'R'=>'ARG',
     'H'=>'HIS',
     'F'=>'PHE',
     'Y'=>'TYR',
     'W'=>'TRP',

     'a'=>'CYS',
     'b'=>'CYS',
     'c'=>'CYS',
     'd'=>'CYS',
     'e'=>'CYS',
     'f'=>'CYS',
     'g'=>'CYS',
     'h'=>'CYS',
     'i'=>'CYS',
     'j'=>'CYS',
     'k'=>'CYS',
     'l'=>'CYS',
     'm'=>'CYS',
     'n'=>'CYS',
     'o'=>'CYS',
     'p'=>'CYS',
     'q'=>'CYS',
     'r'=>'CYS',
     's'=>'CYS',
     't'=>'CYS',
     'u'=>'CYS',
     'v'=>'CYS',
     'w'=>'CYS',
     'x'=>'CYS',
     'y'=>'CYS',
     'z'=>'CYS',

     'B'=>'ASX',
     'Z'=>'GLX',
     'X'=>'CYS',
    );
######>add
%zscore0=(
          'MUSTER'=>5.8,
          'dPPAS'=>9.3,
          'wdPPAS'=>9.0,
          'wPPAS'=>7.5,
          'wMUSTER'=>6.0,
          'dPPAS2'=>10.5,
          'PPAS'=>7.0,
          'Env-PPAS'=>8.0,
          );


%standadSA=(
     'GLY'=>88.1,
     'ALA'=>118.1,
     'VAL'=>164.5,
     'LEU'=>193.1,
     'ILE'=>181.0,
     'SER'=>129.8,
     'THR'=>152.5,
     'CYS'=>146.1,
     'MET'=>203.4,
     'PRO'=>146.8,
     'ASP'=>158.7,
     'ASN'=>165.5,
     'GLU'=>186.2,
     'GLN'=>193.2,
     'LYS'=>225.8,
     'ARG'=>256.0,
     'HIS'=>202.5,
     'PHE'=>222.8,
     'TYR'=>236.8,
     'TRP'=>266.3,

     'G'=>88.1,
     'A'=>118.1,
     'V'=>164.5,
     'L'=>193.1,
     'I'=>181.0,
     'S'=>129.8,
     'T'=>152.5,
     'C'=>146.1,
     'M'=>203.4,
     'P'=>146.8,
     'D'=>158.7,
     'N'=>165.5,
     'E'=>186.2,
     'Q'=>193.2,
     'K'=>225.8,
     'R'=>256.0,
     'H'=>202.5,
     'F'=>222.8,
     'Y'=>236.8,
     'W'=>266.3
 );
########### get Lch ########
open(rmsinp,"$input/rmsinp");
<rmsinp>=~/\S+\s+(\S+)/;
$Lch=$1;
#printf $Lch;
close(rmsinp);
open(seqdat,"$input/seq.dat");
for($i=1;$i<=$Lch;$i++){
    <seqdat>=~/\S+\s+(\S+)/;
    $seqQ{$i}=$ts{$1};
}
close(seqdat);

##############################################################


##############################################################
# Step2: make comb$o.dat from init_all.dat

open(temp,"$initall");
<temp>=~/(\S+)\s+(\S+)/;
$type=$2;
close(temp);

#chunk-------->
$usechunk="no"; #yes, use chunk for comb.dat; no, not use chunk for comb.dat
$init1=""; #chunks
$m_top=12;
$mag=1;
$n_int_CHU=8; #take one distance each 10 residues
$M0_CHU=1; #number of chunk_template used to extract distL.dat

#ROS---------->
$useROS="no"; #ROS cannot be used in additional comb because of redundancy
$init2=""; #ROS
$m_top2=0;
$mag2=1;
$n_int_CHU2=8; #take one distance each 10 residues
$M0_CHU2=1; #number of ROS_templates used to extract distL.dat
$NROS=9;

#chunk_T------->
$usechunk_T="no";
$init3=""; #chunk_T
$m_top3=6; #top 10 models at each chunk_T position
$mag3=1; #no use
$n_int_CHU3=8; #take one distance each 10 residues
$M0_CHU3=1; #number of chunkT_templates used to extract distL.dat
$Z_cut=0;

@AA=qw(
       GLY
       ALA
       SER
       CYS
       VAL
       THR
       ILE
       PRO
       MET
       ASP
       ASN
       LEU
       LYS
       GLU
       GLN
       ARG
       HIS
       PHE
       TYR
       TRP
       );

############# read side-chain parameters ###############
$ka1{GLY}=0.000;  $kb1{GLY}=0.000;  $kc1{GLY}=0.000; $ka2{GLY}=0.000;  $kb2{GLY}=0.000;  $kc2{GLY}=0.000; 
$ka1{ALA}=0.249;  $kb1{ALA}=-1.118; $kc1{ALA}=0.976; $ka2{ALA}=0.113;  $kb2{ALA}=-0.736; $kc2{ALA}=1.294; 
$ka1{SER}=0.169;  $kb1{SER}=-1.369; $kc1{SER}=1.103; $ka2{SER}=0.227;  $kb2{SER}=-0.966; $kc2{SER}=1.427; 
$ka1{CYS}=-0.073; $kb1{CYS}=-1.201; $kc1{CYS}=1.476; $ka2{CYS}=0.084;  $kb2{CYS}=-0.738; $kc2{CYS}=1.712; 
$ka1{VAL}=0.274;  $kb1{VAL}=-1.162; $kc1{VAL}=1.480; $ka2{VAL}=0.093;  $kb2{VAL}=-0.583; $kc2{VAL}=1.799; 
$ka1{THR}=0.090;  $kb1{THR}=-1.296; $kc1{THR}=1.346; $ka2{THR}=0.070;  $kb2{THR}=-0.854; $kc2{THR}=1.633; 
$ka1{ILE}=0.100;  $kb1{ILE}=-1.363; $kc1{ILE}=1.769; $ka2{ILE}=-0.105; $kb2{ILE}=-0.601; $kc2{ILE}=2.135; 
$ka1{PRO}=-0.743; $kb1{PRO}=-1.563; $kc1{PRO}=0.438; $ka2{PRO}=-0.980; $kb2{PRO}=-1.183; $kc2{PRO}=0.976; 
$ka1{MET}=-0.049; $kb1{MET}=-1.246; $kc1{MET}=2.308; $ka2{MET}=0.094;  $kb2{MET}=-0.723; $kc2{MET}=2.610; 
$ka1{ASP}=-0.221; $kb1{ASP}=-1.249; $kc1{ASP}=1.769; $ka2{ASP}=0.334;  $kb2{ASP}=-0.664; $kc2{ASP}=1.992; 
$ka1{ASN}=-0.357; $kb1{ASN}=-1.096; $kc1{ASN}=1.849; $ka2{ASN}=0.097;  $kb2{ASN}=-0.699; $kc2{ASN}=1.962; 
$ka1{LEU}=-0.057; $kb1{LEU}=-1.161; $kc1{LEU}=2.128; $ka2{LEU}=0.003;  $kb2{LEU}=-0.393; $kc2{LEU}=2.400; 
$ka1{LYS}=0.027;  $kb1{LYS}=-1.616; $kc1{LYS}=2.597; $ka2{LYS}=-0.019; $kb2{LYS}=-0.745; $kc2{LYS}=2.972; 
$ka1{GLU}=-0.013; $kb1{GLU}=-1.554; $kc1{GLU}=2.219; $ka2{GLU}=0.101;  $kb2{GLU}=-0.793; $kc2{GLU}=2.684; 
$ka1{GLN}=-0.086; $kb1{GLN}=-1.439; $kc1{GLN}=2.296; $ka2{GLN}=0.041;  $kb2{GLN}=-0.707; $kc2{GLN}=2.666; 
$ka1{ARG}=0.113;  $kb1{ARG}=-1.932; $kc1{ARG}=2.933; $ka2{ARG}=-0.020; $kb2{ARG}=-0.998; $kc2{ARG}=3.394; 
$ka1{HIS}=-0.221; $kb1{HIS}=-1.138; $kc1{HIS}=2.165; $ka2{HIS}=-0.133; $kb2{HIS}=-0.598; $kc2{HIS}=2.363; 
$ka1{PHE}=0.111;  $kb1{PHE}=-0.984; $kc1{PHE}=2.447; $ka2{PHE}=-0.363; $kb2{PHE}=-0.632; $kc2{PHE}=2.507; 
$ka1{TYR}=0.128;  $kb1{TYR}=-1.035; $kc1{TYR}=2.604; $ka2{TYR}=-0.375; $kb2{TYR}=-0.601; $kc2{TYR}=2.706; 
$ka1{TRP}=0.476;  $kb1{TRP}=-1.156; $kc1{TRP}=2.541; $ka2{TRP}=-0.058; $kb2{TRP}=-0.427; $kc2{TRP}=2.894; 
########################################################

############# read cut-off from concut.comm ############
open(concut,"$i_tasser/common/contact.comm");
########## read <cut>------------->
<concut>;
foreach $A(@AA){
    <concut>=~/\S+\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/;
    $i=0;
    foreach $a(@AA){
	$i++;
	$cut=$$i;
	$cutoff{$A,$a}=$cut;
    }
}
########## read <delta>------------->
<concut>;
foreach $A(@AA){
    <concut>=~/\S+\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/;
    $i=0;
    foreach $a(@AA){
	$i++;
	$dev=$$i;
	$cutoff{$A,$a}=$cutoff{$A,$a}+2.5*$dev;
    }
}
close(concut);
########################################################
open(temp,"$initall");
<temp>;
if(<temp>=~/\S+\s+(\S+)\s+\S+\s+\S+\s+(\S+)/){
    $zscore1=$1;
    $T1=$2;
}
close(temp);
######<add
###########################################################
############# LOMETS templates MSA ########################
############# get features of templates ###################
###########################################################
open(temp,"$initall");
<temp>=~/(\S+)\s+(\S+)\s+(\S+)/;
$n_temp=$1;
$type=$2;
$n_good=$3; #only useful for medium targets
if($type eq "easy"){
    $n_top=20;
}elsif($type eq "medm"){
    $n_top=30;
    if($zscore0{$T1} > 0){
	$n_top=$n_good if($zscore1>(3*$zscore0{$T1}));
    }
}else{
    $n_top=50;
}
$n_temp=$n_top if($n_temp>$n_top); #number of templates in use


$it=0;
$it_hdx=0;
%pdb_all={};
%Lali={};
print "$n_temp+*******************\n";
for($j=1;$j<=$n_temp;$j++){
    #1######### read CA from template ################
    undef %mk;
    $line=<temp>;
    $head=$line;
    if($line=~/\S/){
	printf "            nt=$j $line";
    }
    $threading_format="yes";
    if($line=~/(\S+)\s+\S+\s+\S+\s+(\S+)\s+(\S+)/){
	$L_ali=$1;
	$template_name=$2;
	$template_name=~s/\@//mg;
	$ori=$3;
    }elsif($line=~/(\S+)\s+\S+\s+\S+\s+(\S+)/){
	$L_ali=$1;
	$template_name=$2;
	$template_name=~s/\@//mg;
	$ori="unknown";
    }
    for($k=1;$k<=$L_ali;$k++){
	$line=<temp>;
	$i_res{$k}=substr($line,22,4); #order number of target residues
	$i_res{$k}=~s/\s//mg;
	$seq{$i_res{$k}}=substr($line,17,3); #real aa
	$mk{$i_res{$k}}=1;
	$xc{$i_res{$k}}=substr($line,30,8);
	$yc{$i_res{$k}}=substr($line,38,8);
	$zc{$i_res{$k}}=substr($line,46,8);
	if(substr($line,54,9)=~/(\d+)\s+\S\S\S/){
	    $j_res{$k}=$1;    #order number of template residues
	    $j_res{$k}=~s/\s//mg;
	}else{
	    $threading_format="no"; #if threading_format is no, we will calculate side-chain
	}
    }
    <temp>;
    
    #1a####### if template is not from threading, calculate SG ################
    if($zscore0{$ori} == -1 || $ori eq "unknown" || $threading_format eq "no"){ # this template is not from threading
	goto SG0;
    }
    
    #2######## read sidechain from PDB library ########################
    undef %n_atom;
    if($ori eq "BBB" || $ori=~/RAP/ || $ori eq "pgen" || $ori eq "WWW" || $threading_format eq "no"){
	$ori="unknown";
	goto SG0;
    }
    
    $pdbfile="$librarydir/PDB/$template_name\.pdb";
	
    if(!-s "$pdbfile"){
	printf "warning: $ori --- $pdbfile doesnot exist or not threading format (we will regenerate side-chain from Ca)!!\n";
	printf "$line";
	$ori="unknown";
	goto SG0;
    }


    `$dssp $pdbfile $datadir/$template_name$ori.dssp`;
    $it=$it+1;
    open(dssp,"$datadir/$template_name$ori.dssp");
    #print "$it <<<<<<<<<<<<<<<<<<<<<<<<<$template_name$ori.dssp\n";
    while($line=<dssp>){
	if($line=~/\#  RESIDUE AA STRUCTURE/){
	    while($line=<dssp>){
		$index=substr($line,6,4);
		$index=~s/\s//mg;

		$aa=substr($line,12,2);
		$aa=~s/\s//mg;
		$AA{$it,$index}=$aa;
	    }
       }
    }
    close(dssp);
    ########## modify j_res based on pdb file##################
    $site='';
    open(mdpdb,"$pdbfile");
    while($pdb_line=<mdpdb>){
	if($pdb_line=~/$xc{$i_res{1}}/){
	    if($pdb_line=~/$yc{$i_res{1}}/){
		if($pdb_line=~/$zc{$i_res{1}}/){
		    #printf "%%%%%%%%%%%%$pdb_line\n";
		    $site=substr($pdb_line,21,5);
		    $site=~s/\s//mg;
		    break;
		}
	    }
	}
    }
    close(mdpdb);
    if($site==''){
	$it--;
	goto SG0;
    }

    $diff=int($j_res{1})-int($site);
    $num_match=0;
    for($k=1;$k<=$Lch;$k++){
	if($mk{$k}==1){
	    $num_match++;
	    $match{$it,$k}=int($j_res{$num_match})-$diff;
	}
	else{
	    $match{$it,$k}='-';
	}
    }


    ########## modify Template pdb based on target sequence##################
    $pdb_all{$it}=$pdbfile;
    $Lali{$it}=$L_ali;
    open(outpdb,">$work_dir/modify$it.pdb");
    $i_num=0;
    for($k=1;$k<=$Lch;$k++){
	if($match{$it,$k} eq '-'){
	    next;
	}
	$i_num++;
	open(mdpdb,"$pdbfile");
	while($pdb_line=<mdpdb>){
	    #print $pdb_line;
	    $record=substr($pdb_line,0,4);
	    if($record eq "ATOM"){
		$Lt=substr($pdb_line,22,4);
		$Lt=~s/\s//mg;
		#print "$Lt\n";
		if($match{$it,$k} == $Lt){
		    if($i_res{$i_num}<10){
			$new_index = "   $i_res{$i_num}";
		    }
		    elsif($i_res{$i_num}<100){
			$new_index = "  $i_res{$i_num}";
		    }
		    elsif($i_res{$i_num}<1000){
			$new_index = " $i_res{$i_num}";
		    }
		    elsif($i_res{$i_num}<10000){
			$new_index = "$i_res{$i_num}";
		    }
		    $new_line = substr($pdb_line, 22, 4, $new_index);
		    #print "$pdb_line";
		    printf outpdb $pdb_line;
		}
	    }
	}
	close(mdpdb);
    }
    close(outpdb);
  SG0:;
}

close(temp);
######>add


######<add

###################################################################
########## sort templates based on TM-score ##############
###################################################################

%TM_score={};

for($i=1;$i<=$it;$i++){
    #print "*********************************************$i\n";
    for($j=1;$j<=$it;$j++){
	if($i == $j){
	    next;
	}
	$d_0 = 1.24*(($Lch-15)**(1/3)-1.8);
	$rst=`$i_tasser/bin/TMscore $work_dir/modify$i.pdb $work_dir/modify$j.pdb -d $d_0`;
	if($rst=~/TM-score    =\s*(\S+)/){
	    $TM_score{$i,$j} = $1;
	    #print "$TM_score{$i,$j} ";
	}
    }
    #printf "\n";
}
for($i=1;$i<=$it;$i++){
    $TM_score{$i,$i} = 1;
}

%Tw={};
$sum_Tw=0;
for($i=1;$i<=$it;$i++){
    for($j=1;$j<=$it;$j++){
	if($i != $j){
	    $Tw{$i}+=$Lali{$j}*$TM_score{$i,$j}/$Lch;
	}
    }
    $Tw{$i}=$Tw{$i}/($it-1);
    $sum_Tw+=$Tw{$i};
} 



###################################################################
########## calulate statistical Potentials           ##############
###################################################################

%pos_mut={};
$mut_num=0;
%mutant_type={};
$mut_num++;
$wild_type{$mut_num} = $wild;
$pos_mut{$mut_num} = $position;
$mutant_type{$mut_num} = $mutant;


######## print statistical Potentials ------------>    


%TMscore1=Get_TMscore();  #1*mut_num



%BLOSUM1=Get_BLOSUM();  #1*mut_num



open(ew,">$datadir/seq_mt.we");
printf ew "$type  n_temp=$n_temp  n_pdb=$it\n";
#print "$mut_num((((((((\n";

for($i=1;$i<=$mut_num;$i++){
    printf ew "1 %5s %3s  ", $pos_mut{$i},$mutant_type{$i};
    if($BLOSUM1{$i}=='-'){
	printf ew "%8s  ", $BLOSUM1{$i};
    }
    else{
	printf ew "%8f  ", $BLOSUM1{$i};
    }
    printf ew "\n";
}



for($i=1;$i<=$mut_num;$i++){
    printf ew "3 %5s %3s  ", $pos_mut{$i},$mutant_type{$i};
    if($TMscore1{$i}=='-'){
	printf ew "%8s  ", $TMscore1{$i};
    }
    else{
	printf ew "%8f  ", $TMscore1{$i};
    }
    printf ew "\n";
}


close(ew);
######>add


#^^^^^^^^^^^^^^^^ XXX.we done ^^^^^^^^^^^^^^^


sleep(1);
#`/bin/rm -f $work_dir/*.pdb`;
#`/bin/rm -f $work_dir/*.dssp`;
exit();






sub Get_BLOSUM
{
    my $i;
    my $j;
    my @words;
    my @b62;

    my %aaNum = (
        A => 0,
        R => 1,
        N => 2,
        D => 3,
        C => 4,
        Q => 5,
        E => 6,
        G => 7,
        H => 8,
        I => 9,
        L => 10,
        K => 11,
        M => 12,
        F => 13,
        P => 14,
        S => 15,
        T => 16,
        W => 17,
        Y => 18,
        V => 19,
    );

    my $blosum62 = <<BLOSUM;
#  BLOSUM Clustered Target Frequencies=qij
#  Blocks Database = /data/blocks_5.0/blocks.dat
#  Cluster Percentage: >= 62
   A      R      N      D      C      Q      E      G      H      I      L      K      M      F      P      S      T      W      Y      V
0.0215
0.0023 0.0178
0.0019 0.0020 0.0141
0.0022 0.0016 0.0037 0.0213
0.0016 0.0004 0.0004 0.0004 0.0119
0.0019 0.0025 0.0015 0.0016 0.0003 0.0073
0.0030 0.0027 0.0022 0.0049 0.0004 0.0035 0.0161
0.0058 0.0017 0.0029 0.0025 0.0008 0.0014 0.0019 0.0378
0.0011 0.0012 0.0014 0.0010 0.0002 0.0010 0.0014 0.0010 0.0093
0.0032 0.0012 0.0010 0.0012 0.0011 0.0009 0.0012 0.0014 0.0006 0.0184
0.0044 0.0024 0.0014 0.0015 0.0016 0.0016 0.0020 0.0021 0.0010 0.0114 0.0371
0.0033 0.0062 0.0024 0.0024 0.0005 0.0031 0.0041 0.0025 0.0012 0.0016 0.0025 0.0161
0.0013 0.0008 0.0005 0.0005 0.0004 0.0007 0.0007 0.0007 0.0004 0.0025 0.0049 0.0009 0.0040
0.0016 0.0009 0.0008 0.0008 0.0005 0.0005 0.0009 0.0012 0.0008 0.0030 0.0054 0.0009 0.0012 0.0183
0.0022 0.0010 0.0009 0.0012 0.0004 0.0008 0.0014 0.0014 0.0005 0.0010 0.0014 0.0016 0.0004 0.0005 0.0191
0.0063 0.0023 0.0031 0.0028 0.0010 0.0019 0.0030 0.0038 0.0011 0.0017 0.0024 0.0031 0.0009 0.0012 0.0017 0.0126
0.0037 0.0018 0.0022 0.0019 0.0009 0.0014 0.0020 0.0022 0.0007 0.0027 0.0033 0.0023 0.0010 0.0012 0.0014 0.0047 0.0125
0.0004 0.0003 0.0002 0.0002 0.0001 0.0002 0.0003 0.0004 0.0002 0.0004 0.0007 0.0003 0.0002 0.0008 0.0001 0.0003 0.0003 0.0065
0.0013 0.0009 0.0007 0.0006 0.0003 0.0007 0.0009 0.0008 0.0015 0.0014 0.0022 0.0010 0.0006 0.0042 0.0005 0.0010 0.0009 0.0009 0.0102
0.0051 0.0016 0.0012 0.0013 0.0014 0.0012 0.0017 0.0018 0.0006 0.0120 0.0095 0.0019 0.0023 0.0026 0.0012 0.0024 0.0036 0.0004 0.0015 0.0196
BLOSUM

    $i = 0;
    my @blosum62 = split( /\n/, $blosum62 );

    # read/build the blosum matrix
    foreach my $blosumline (@blosum62) {
	next if ( $blosumline !~ /^\d/ );
        chomp $blosumline;
        @words = split( /\s/, $blosumline );
	#print "$#words \n";
        for($j= 0;$j<=$#words;++$j ){
            $b62[$i][$j]=$words[$j];
            $b62[$j][$i]=$words[$j];
        }
        ++$i;
    }

    # normalize the blosum matrix so that each row sums to 1.0
    for ( $i = 0 ; $i < 20 ; ++$i ) {
        $sum = 0.0;
        for ( $j = 0 ; $j < 20 ; ++$j ) {
            $sum += $b62[$i][$j];
        }
        for ( $j = 0 ; $j < 20 ; ++$j ) {
            $b62[$i][$j] = ( $b62[$i][$j] / $sum );
        }
    }

    my %we = {};
    my %num = {};
    for($j=1;$j<=$mut_num;$j++){
	for($i=1;$i<=$it;$i++){
	    next if ($match{$i,$pos_mut{$j}} eq '-');
	    $num{$j}++;
	    $we{$j} += $b62[$aaNum{$AA{$i,$match{$i,$pos_mut{$j}}}}][$aaNum{$mutant_type{$j}}];
	}
    }
    for($j=1;$j<=$mut_num;$j++){
	if($num{$j}==0){
	    $we{$j}='-';
	    next;
	}
	$we{$j} = $we{$j}/$num{$j};
    }
    return %we;
}




sub Get_TMscore
{
    my $i;
    my $j;
    my @words;
    my @b62;

    my %aaNum = (
        A => 0,
        R => 1,
        N => 2,
        D => 3,
        C => 4,
        Q => 5,
        E => 6,
        G => 7,
        H => 8,
        I => 9,
        L => 10,
        K => 11,
        M => 12,
        F => 13,
        P => 14,
        S => 15,
        T => 16,
        W => 17,
        Y => 18,
        V => 19,
    );

    my $blosum62 = <<BLOSUM;
#  BLOSUM Clustered Target Frequencies=qij
#  Blocks Database = /data/blocks_5.0/blocks.dat
#  Cluster Percentage: >= 62
   A      R      N      D      C      Q      E      G      H      I      L      K      M      F      P      S      T      W      Y      V
0.0215
0.0023 0.0178
0.0019 0.0020 0.0141
0.0022 0.0016 0.0037 0.0213
0.0016 0.0004 0.0004 0.0004 0.0119
0.0019 0.0025 0.0015 0.0016 0.0003 0.0073
0.0030 0.0027 0.0022 0.0049 0.0004 0.0035 0.0161
0.0058 0.0017 0.0029 0.0025 0.0008 0.0014 0.0019 0.0378
0.0011 0.0012 0.0014 0.0010 0.0002 0.0010 0.0014 0.0010 0.0093
0.0032 0.0012 0.0010 0.0012 0.0011 0.0009 0.0012 0.0014 0.0006 0.0184
0.0044 0.0024 0.0014 0.0015 0.0016 0.0016 0.0020 0.0021 0.0010 0.0114 0.0371
0.0033 0.0062 0.0024 0.0024 0.0005 0.0031 0.0041 0.0025 0.0012 0.0016 0.0025 0.0161
0.0013 0.0008 0.0005 0.0005 0.0004 0.0007 0.0007 0.0007 0.0004 0.0025 0.0049 0.0009 0.0040
0.0016 0.0009 0.0008 0.0008 0.0005 0.0005 0.0009 0.0012 0.0008 0.0030 0.0054 0.0009 0.0012 0.0183
0.0022 0.0010 0.0009 0.0012 0.0004 0.0008 0.0014 0.0014 0.0005 0.0010 0.0014 0.0016 0.0004 0.0005 0.0191
0.0063 0.0023 0.0031 0.0028 0.0010 0.0019 0.0030 0.0038 0.0011 0.0017 0.0024 0.0031 0.0009 0.0012 0.0017 0.0126
0.0037 0.0018 0.0022 0.0019 0.0009 0.0014 0.0020 0.0022 0.0007 0.0027 0.0033 0.0023 0.0010 0.0012 0.0014 0.0047 0.0125
0.0004 0.0003 0.0002 0.0002 0.0001 0.0002 0.0003 0.0004 0.0002 0.0004 0.0007 0.0003 0.0002 0.0008 0.0001 0.0003 0.0003 0.0065
0.0013 0.0009 0.0007 0.0006 0.0003 0.0007 0.0009 0.0008 0.0015 0.0014 0.0022 0.0010 0.0006 0.0042 0.0005 0.0010 0.0009 0.0009 0.0102
0.0051 0.0016 0.0012 0.0013 0.0014 0.0012 0.0017 0.0018 0.0006 0.0120 0.0095 0.0019 0.0023 0.0026 0.0012 0.0024 0.0036 0.0004 0.0015 0.0196
BLOSUM

    $i = 0;
    my @blosum62 = split( /\n/, $blosum62 );

    # read/build the blosum matrix
    foreach my $blosumline (@blosum62) {
	next if ( $blosumline !~ /^\d/ );
        chomp $blosumline;
        @words = split( /\s/, $blosumline );
	#print "$#words \n";
        for($j= 0;$j<=$#words;++$j ){
            $b62[$i][$j]=$words[$j];
            $b62[$j][$i]=$words[$j];
        }
        ++$i;
    }

    # normalize the blosum matrix so that each row sums to 1.0
    for ( $i = 0 ; $i < 20 ; ++$i ) {
        $sum = 0.0;
        for ( $j = 0 ; $j < 20 ; ++$j ) {
            $sum += $b62[$i][$j];
        }
        for ( $j = 0 ; $j < 20 ; ++$j ) {
            $b62[$i][$j] = ( $b62[$i][$j] / $sum );
        }
    }

    my %we = {};
    my %num = {};
    for($j=1;$j<=$mut_num;$j++){
	for($i=1;$i<=$it;$i++){
	    if ($match{$i,$pos_mut{$j}} eq '-'){
		#print "^^^^^^^^^^^^^^^^^^^^$i   $j   $pos_mut{$j}\n";
		next;
	    }
	    $num{$j}++;
	    #print "$AA{$i,$match{$i,$pos_mut{$j}}}\n";
	    $we{$j} += $Tw{$i}*$b62[$aaNum{$AA{$i,$match{$i,$pos_mut{$j}}}}][$aaNum{$mutant_type{$j}}];
	}
    }
    
    for($j=1;$j<=$mut_num;$j++){
	if($num{$j}==0){
	    $we{$j}='-';
	    next;
	}
	$we{$j} = $we{$j}/$num{$j};
    }
    return %we;
}

