#!/usr/bin/perl
use Math::Trig;



########### setup  the environment and Working DIRectory ###
$data_dir=@ARGV[0]; 
$out_dir=@ARGV[1];
$itasser=@ARGV[2];
$libdir_local=@ARGV[3];
$pdb=@ARGV[4];

%ts=(
     'GLY'=>'G',
     'ALA'=>'A',
     'VAL'=>'V',
     'LEU'=>'L',
     'ILE'=>'I',
     'SER'=>'S',
     'THR'=>'T',
     'CYS'=>'C',
     'MET'=>'M',
     'PRO'=>'P',
     'ASP'=>'D',
     'ASN'=>'N',
     'GLU'=>'E',
     'GLN'=>'Q',
     'LYS'=>'K',
     'ARG'=>'R',
     'HIS'=>'H',
     'PHE'=>'F',
     'TYR'=>'Y',
     'TRP'=>'W',

     'ASX'=>'B',
     'GLX'=>'Z',
     'UNK'=>'X',

     'G'=>'GLY',
     'A'=>'ALA',
     'V'=>'VAL',
     'L'=>'LEU',
     'I'=>'ILE',
     'S'=>'SER',
     'T'=>'THR',
     'C'=>'CYS',
     'M'=>'MET',
     'P'=>'PRO',
     'D'=>'ASP',
     'N'=>'ASN',
     'E'=>'GLU',
     'Q'=>'GLN',
     'K'=>'LYS',
     'R'=>'ARG',
     'H'=>'HIS',
     'F'=>'PHE',
     'Y'=>'TYR',
     'W'=>'TRP',

     'a'=>'CYS',
     'b'=>'CYS',
     'c'=>'CYS',
     'd'=>'CYS',
     'e'=>'CYS',
     'f'=>'CYS',
     'g'=>'CYS',
     'h'=>'CYS',
     'i'=>'CYS',
     'j'=>'CYS',
     'k'=>'CYS',
     'l'=>'CYS',
     'm'=>'CYS',
     'n'=>'CYS',
     'o'=>'CYS',
     'p'=>'CYS',
     'q'=>'CYS',
     'r'=>'CYS',
     's'=>'CYS',
     't'=>'CYS',
     'u'=>'CYS',
     'v'=>'CYS',
     'w'=>'CYS',
     'x'=>'CYS',
     'y'=>'CYS',
     'z'=>'CYS',

     'B'=>'ASX',
     'Z'=>'GLX',
     'X'=>'CYS',
    );

###############################################################
#make 'exp.dat'
###############################################################
@ww=qw(
       0.05
       0.10
       0.15
       0.20
       0.25
       0.30
       0.35
       0.40
       0.45
       0.50
       0.55
       0.60
       0.65
       0.70
       0.75
       0.80
       0.85
       );
if(-s "$data_dir/exp.dat")
{
    open(explist,"$data_dir/exp.dat");
    $n_line=0;
    while($expline=<explist>)
    {
	$n_line++;
    }
    close(explist);
    if($n_line>=2)
    {
	goto pos_SA;
    }
}

`cp $itasser/bin/solve $out_dir`;
`cp $itasser/data/wgt.tar.bz2 $out_dir`;
`tar -jxvf $out_dir/wgt.tar.bz2`;
`cp $data_dir/pssm.txt $out_dir/protein.mat3`;

############# run solvent ##################
foreach $w(@ww)
{
    `$out_dir/solve $out_dir/weight.$w protein`; #protein.neu
    open(neu,"protein.neu");
    <neu>=~/(\d+)/;
    $Lch=$1;
    for($i=1;$i<=$Lch;$i++)
    {
	<neu>=~/(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/;
	$exp{$i,$w}=$5;
    }
    close(neu);
}
open(exp1,">$out_dir/protein.exp");
printf exp1 "$Lch  ";
foreach $w(@ww)
{
    printf exp1 " %5s",$w;
}
printf exp1 "\n";
for($i=1;$i<=$Lch;$i++)
{
    printf exp1 "%5d",$i;
    foreach $w(@ww)
    {
	printf exp1 " %5d",$exp{$i,$w};
    }
    printf exp1 "\n";
}
close(exp1);
`cp $out_dir/protein.exp $data_dir/exp.dat`;

pos_SA:;
open(fl,"$data_dir/exp.dat");
<fl>; #skip this line
$in=0;
while($line=<fl>)
{
    $line=~/\S+\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/;
    for($pp=1;$pp<=17;$pp++)
    {
        if($$pp==0)
        {
            last;
        }
    }
    $exp[$in]=($pp-1)/20;#exposed    
    $in++;
}
close(fl);

open(wfl,">$out_dir/seq.exp.sa");
printf wfl "$in\n";
for($i=0;$i<$in;$i++)
{
    printf wfl "%-4d %8.2f\n",$i+1,$exp[$i];
}
close(wfl);


###############################################################
#make '$pdb\_pssm.txt'
###############################################################

#####generate seq.svr.psi and seq.svr.phi ######
chdir "$out_dir";
`cp $itasser/bin/MUSTER/bin/construct_input_torsion.pl $out_dir`;
`cp $itasser/bin/MUSTER/bin/predict_psi.pl $out_dir`;
`cp $itasser/bin/MUSTER/bin/predict_phi.pl $out_dir`;
`cp $itasser/bin/MUSTER/bin/svm-predict $out_dir/`;
`cp $data_dir/exp.dat $out_dir`;
`cp $data_dir/pssm.txt $out_dir/$pdb\_pssm.txt`;
`cp $data_dir/seq.dat $out_dir`;
`$out_dir/construct_input_torsion.pl 10 $out_dir/$pdb`;
`$out_dir/predict_psi.pl $libdir_local`;
`$out_dir/predict_phi.pl $libdir_local`;

