#!/usr/bin/perl -w
# Nov. 2008, by Eshel Faraggi
# Sep. 2011, by Yuedong Yang
#
# Reference: E. Faraggi*, Y. Yang*, S. Zhang and Y. Zhou. Predicting continuous local structure and the effect of its substitution for secondary structure in fragment-free protein structure prediction, Structure 17,1515-1527 (2009)

# Send error messages to the user, not system log
	open(STDERR,'<&STDOUT'); $| = 1;   
	if (@ARGV < 1 or ($ARGV[0] !~ /\.pssm$/ and $ARGV[0] !~ /\.mat$/)){
		die("usage: $0 *.pssm\nFiles ending with .pssm is PSSM from psiblast\n\n"); 
	}
#   print "To get some help use $0 -h\n";
#   $spcodir = $ENV{'spineXcodir'};
# $spcodir = "/data1/yueyang/local/SPINE/RS4_standalone/";

if(-d "/nfs/amino-library")
{
    $spcodir = "/nfs/amino-library/SPARKX/sparks-x/SPINE-X";
}
else
{
    $spcodir = "/library/yzhang/SPARKX/sparks-x/SPINE-X";
}
	$spcodir = dirname($0);
	if (! -e "$spcodir/weights" and -e "$spcodir/../weights") {
		$spcodir = "$spcodir/../";
	}
	$codir = "$spcodir/bin";
	if(! -d "$codir") {
	   die "no setting of SPARKSXDIR or director not exists: $codir\n";
	}
	for($i=1; $i<1000; $i++){
		$workdir = "spxtmp$i/";
		next if -d $workdir;
		mkdir $workdir or die "Can't make temp. dir. ($workdir) aborting\n";
		last
	}
	if($i >= 1000) {die "too many directory in /tmp/spxtemp\n";}
	$tmpfet = $workdir . "/tmp.inpfet";
	foreach(@ARGV){
		&run1($_);
	}
   `rm -f $workdir/*`;
   `rmdir $workdir`;

sub run1{
	($pro_mat) = @_;
	use File::Basename;
	if($pro_mat =~ /\.mat$/) {$pro_bn = basename($pro_mat, ".mat");}
	elsif($pro_mat =~ /\.pssm$/) {$pro_bn = basename($pro_mat, ".pssm");}
	else {$pro_bn = basename($pro_mat, ".mat");}
	`$codir/buildinp_mat.pl $pro_mat > $tmpfet`;
   system("$codir/phipsi_ss0.e $workdir $spcodir")==0 or die "Aborting: Can't run first SS0 predictor\n";

   system("$codir/phipsi_rsa.e $workdir $spcodir")==0 or die "Aborting: Can't run ASA predictor\n";
#  `cp fort.99 sigma_asa.out`;
#  print "Prediction + error (SD) for ASA in sigma_asa.out\n";

#   system("$codir/phipsi_cn.e $i $spcodir")==0 or die "Aborting: Can't run CN predictor\n";
#   `cp fort.99 sigma_cn.out`;
#   `mv fort.99 $workdir/phipsi_cn.$i`;
#  print "Prediction + error (SD) for CN/HSE in sigma_cn.out\n";
   
   system("$codir/phipsi_phipsi0.e $workdir $spcodir")==0 or die "Aborting: Can't run first phi/psi predictor\n";
#  `mv fort.99 $workdir/phipsi_phipsi0.$i`;
   
    system("$codir/phipsi_ss1.e $workdir $spcodir")==0 or die "Aborting: Can't run first second SS predictor\n";
#    `mv fort.99 $workdir/phipsi_ss1.$i`;
     
   system("$codir/phipsi_phipsi1.e $workdir $spcodir")==0 or die "Aborting: Can't run first second SS predictor\n";
   
#  `echo ">$pro_bn" > phipsi.out`;
   print "Here\n";
#  print "cp -n $workdir/phipsi_phipsi1 $pro_bn.phipsi\n";

   `cp  $workdir/phipsi_phipsi1 $pro_bn.phipsi`;

#   `cp -n $workdir/phipsi_phipsi1 $pro_bn.phipsi`;
#   `rm -f fort.99`;
}
